using fgxavi.Mvvm;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;

namespace Sigcat.Client.Model.Directorate
{

    public partial class DirectorateModel : ModelBase
    {

        #region Property DirectorateId

        /// <summary>
        /// Membre privat de la propietat <see cref="DirectorateId" />.
        /// </summary>
        private int _DirectorateId = -1;

        /// <summary>
        /// Estableix i obté la propietat <see cref="DirectorateId" />.
        /// Fa ús del mètode <see cref="SetField"/> per establir la propietat.
        /// </summary>
        public int DirectorateId
        {
            get { return _DirectorateId; }
            set { SetField(ref _DirectorateId, value); }
        }

        #endregion

        #region Property Name

        /// <summary>
        /// Membre privat de la propietat <see cref="Name" />.
        /// </summary>
        private string _Name = null;

        /// <summary>
        /// Estableix i obté la propietat <see cref="Name" />.
        /// Fa ús del mètode <see cref="SetField"/> per establir la propietat.
        /// </summary>
        public string Name
        {
            get { return _Name; }
            set { SetField(ref _Name, value); }
        }

        #endregion

        #region Property Icon

        /// <summary>
        /// Membre privat de la propietat <see cref="Icon" />.
        /// </summary>
        private byte[] _Icon = null;

        /// <summary>
        /// Estableix i obté la propietat <see cref="Icon" />.
        /// Fa ús del mètode <see cref="SetField"/> per establir la propietat.
        /// </summary>
        public byte[] Icon
        {
            get { return _Icon; }
            set { SetField(ref _Icon, value); }
        }

        #endregion

        #region Property Comments

        /// <summary>
        /// Membre privat de la propietat <see cref="Comments" />.
        /// </summary>
        private string _Comments = null;

        /// <summary>
        /// Estableix i obté la propietat <see cref="Comments" />.
        /// Fa ús del mètode <see cref="SetField"/> per establir la propietat.
        /// </summary>
        public string Comments
        {
            get { return _Comments; }
            set { SetField(ref _Comments, value); }
        }

        #endregion

        //public virtual ICollection<BuildingTypes> BuildingTypes { get; set; }
        //public virtual ICollection<OrganTypes> OrganTypes { get; set; }
        //public virtual ICollection<Users> Users { get; set; }
        //public virtual ICollection<MapLayers> MapLayers { get; set; }

        //public Directorates()
        //{
        //    this.BuildingTypes = new HashSet<BuildingTypes>();
        //    this.OrganTypes = new HashSet<OrganTypes>();
        //    this.Users = new HashSet<Users>();
        //    this.MapLayers = new HashSet<MapLayers>();
        //}

    }

    public partial class DirectoratesModel : ModelCollectionBase<DirectorateModel>
    {

        #region Constructors

        public DirectoratesModel() : base() { }

        public DirectoratesModel(IEnumerable<DirectorateModel> collection) : base(collection) { }

        public DirectoratesModel(IList<DirectorateModel> list) : base(list) { }

        #endregion

    }

    [MetadataType(typeof(Metadata))]
    [Repository("Directorate", "Directorates")]
    [Entity("Directorate")]
    public partial class DirectorateModel
    {
        internal sealed class Metadata
        {
            [Key]
            [Required]
            [JsonProperty]
            public int DirectorateId { get; set; }
            [Required]
            [JsonProperty]
            public string Name { get; set; }
            [JsonProperty]
            public byte[] Icon { get; set; }
            [JsonProperty]
            public string Comments { get; set; }
        }
    }
}
