﻿using fgxavi.Mvvm;
using System;
using System.Collections.Generic;
using System.Linq.Expressions;
using System.Threading.Tasks;

namespace Sigcat.Client.Model
{
    public interface IRepository<T> where T : ModelBase
    {
        Task<IEnumerable<T>> Browse();
        Task<T> Read(int id);
        //Task<IEnumerable<T>> SearchFor(Expression<Func<T, bool>> predicate);
        Task<ChangeResult<T>> Edit(T entity);
        Task<ChangeResult<T>> Add(T entity);
        Task<ChangeResult<T>> Delete(T entity);
        Task<ChangeResult<ModelBase>> SubmitChange(T entity);
    }
}
