﻿using ESRI.ArcGIS.Client;
using ESRI.ArcGIS.Client.Geometry;

namespace Sigcat.WpfApplication.Model
{
	public class MercatorSchemaTiledLayer : TiledMapServiceLayer
	{
        private const double cornerCoordinate = 20037508.3427892;
		private const int WKID = 102100;

		public override void Initialize()
		{			
            this.FullExtent = 
                new ESRI.ArcGIS.Client.Geometry.Envelope(-cornerCoordinate,-cornerCoordinate,cornerCoordinate,cornerCoordinate)
			{
				SpatialReference = new SpatialReference(WKID)
			};
			
            this.SpatialReference = new SpatialReference(WKID);
			
            this.TileInfo = new TileInfo()
			{
				Height = 256,
				Width = 256,
				Origin = new MapPoint(-cornerCoordinate, cornerCoordinate) { SpatialReference = new ESRI.ArcGIS.Client.Geometry.SpatialReference(WKID) },
				Lods = new Lod[21]
			};
			
            double resolution = cornerCoordinate * 2 / 256;
			for (int i = 0; i < TileInfo.Lods.Length; i++)
			{
				TileInfo.Lods[i] = new Lod() { Resolution = resolution };
				resolution /= 2;
			}
			base.Initialize();
		}
        
        public override string GetTileUrl(int level, int row, int col)
        {
            return null;
        }
    }
}