﻿using fgxavi.Mvvm;
using Newtonsoft.Json;
using System;
using System.ComponentModel.DataAnnotations;

namespace Sigcat.Client.Model.Settings
{

    public partial class SettingsModel : ModelBase
    {

        #region Property AuthenticationService

        /// <summary>
        /// Membre privat amb la propietat <see cref="Type" />.
        /// </summary>
        private ServiceModel _AuthenticationService = null;

        /// <summary>
        /// Estableix i obté la propietat <see cref="AuthenticationService" />.
        /// Fa ús del mètode <see cref="SetField"/> per establir la propietat.
        /// </summary>
        public ServiceModel AuthenticationService
        {
            get { return _AuthenticationService; }
            set { SetField(ref _AuthenticationService, value); }
        }

        #endregion

        #region Property DomainService

        /// <summary>
        /// Membre privat amb la propietat <see cref="Type" />.
        /// </summary>
        private ServiceModel _DomainService = null;

        /// <summary>
        /// Estableix i obté la propietat <see cref="DomainService" />.
        /// Fa ús del mètode <see cref="SetField"/> per establir la propietat.
        /// </summary>
        public ServiceModel DomainService
        {
            get { return _DomainService; }
            set { SetField(ref _DomainService, value); }
        }

        #endregion

    }

    [MetadataType(typeof(Metadata))]
    public partial class SettingsModel
    {
        internal sealed class Metadata
        {
            [Required]
            [JsonProperty]
            public ServiceModel AuthenticationService { get; set; }
            [Required]
            [JsonProperty]
            public ServiceModel DomainService { get; set; }
        }
    }

}
