﻿using fgxavi.Mvvm;
using GalaSoft.MvvmLight.Command;
using Sigcat.Client.Model;
using Sigcat.Client.Model.Directorate;
using System.Threading.Tasks;

namespace Sigcat.Client.ViewModel.Directorate
{
    public class DirectorateViewModel : ViewModelBase
    {

        #region Members

        #region Member IRepository<DirectorateModel>

        /// <summary>
        /// Membre privat amb accés al repositori del model de dades.
        /// </summary>
        private readonly IRepository<DirectorateModel> _repo;

        #endregion

        #endregion

        #region Properties

        //#region Property Directorate

        ///// <summary>
        ///// Membre privat de la propietat <see cref="Directorate" />.
        ///// </summary>
        //private DirectorateModel _Directorate = null;

        ///// <summary>
        ///// Estableix i obté la propietat <see cref="Directorate" />.
        ///// Fa ús del mètode <see cref="SetField"/> per establir la propietat.
        ///// </summary>
        //public DirectorateModel Directorate
        //{
        //    get { return _Directorate; }
        //    set { SetField(ref _Directorate, value); }
        //}

        //#endregion

        #region Property Directorates

        /// <summary>
        /// Membre privat de la propietat <see cref="Directorates" />.
        /// </summary>
        private DirectoratesModel _Directorates = new DirectoratesModel();

        /// <summary>
        /// Estableix i obté la propietat <see cref="Directorates" />.
        /// Fa ús del mètode <see cref="SetField"/> per establir la propietat.
        /// </summary>
        public DirectoratesModel Directorates
        {
            get { return _Directorates; }
            set { SetField(ref _Directorates, value); }
        }

        #endregion

        #endregion

        #region Commands

        #region ViewModelBase.RefreshCommand

        protected override async void ExecuteRefreshCommand()
        {
            var directorates = await _repo.Browse();
            Directorates = new DirectoratesModel(directorates);
            Directorates.SendAcceptChanges += Directorates_ModelAcceptChanges; //+= Directorates_ModelAcceptChanges;
        }

        async void Directorates_ModelAcceptChanges(ModelBase sender)
        {
            ChangeResult<ModelBase> result = await _repo.SubmitChange(sender as DirectorateModel);
            ChangeResultEventArgs<ModelBase> args = new ChangeResultEventArgs<ModelBase>()
            {
                Result = result
            };
            sender.AcceptChangesResult(args);
        }

        protected override bool CanExecuteRefreshCommand()
        {
            return true;
        }

        #endregion

        #endregion

        #region Contructor

        /// <summary>
        /// Contructor per defecte.
        /// </summary>
        public DirectorateViewModel(IRepository<DirectorateModel> repo)
        {
            // Afegeix una referència al servei del model.
            _repo = repo;
            // Obté el model de dades del servei.
            ExecuteRefreshCommand();
        }

        #endregion

    }

}
