﻿using System;
using System.Globalization;
using System.Windows;
using System.Windows.Data;

namespace Sigcat.Client.Views.WpfWindows.Resources.Converters
{

    [ValueConversion(typeof(bool), typeof(object))]
    public class BoolToObjectConverter : IValueConverter
    {

        public object TrueValue { get; set; }
        public object FalseValue { get; set; }

        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            if (!(value is bool))
                return null;
            return (bool)value ? TrueValue : FalseValue;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            if (Equals(value, TrueValue))
                return true;
            if (Equals(value, FalseValue))
                return false;
            return null;
        }

    }

}
