﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Sigcat.Client.Views.WpfWindows.Resources
{
    /// <summary>
    /// Lógica de interacción para SigcatLogo.xaml
    /// </summary>
    public partial class LogoShield : UserControl
    {
        public LogoShield()
        {
            InitializeComponent();
        }

        public Brush BrushShield
        {
            get { return (Brush)GetValue(BrushShieldProperty); }
            set { SetValue(BrushShieldProperty, value); }
        }

        // Using a DependencyProperty as the backing store for BrushShield.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty BrushShieldProperty =
            DependencyProperty.Register("BrushShield", typeof(Brush), typeof(LogoShield), new PropertyMetadata(new SolidColorBrush(Color.FromRgb(255, 230, 16))));

        public Brush BrushBar
        {
            get { return (Brush)GetValue(BrushBarProperty); }
            set { SetValue(BrushBarProperty, value); }
        }

        // Using a DependencyProperty as the backing store for BrushBar.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty BrushBarProperty =
            DependencyProperty.Register("BrushBar", typeof(Brush), typeof(LogoShield), new PropertyMetadata(new SolidColorBrush(Color.FromRgb(228, 27, 19))));

        public Brush BrushBorder
        {
            get { return (Brush)GetValue(BrushBorderProperty); }
            set { SetValue(BrushBorderProperty, value); }
        }

        // Using a DependencyProperty as the backing store for BrushBorder.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty BrushBorderProperty =
            DependencyProperty.Register("BrushBorder", typeof(Brush), typeof(LogoShield), new PropertyMetadata(new SolidColorBrush(Colors.Black)));

        public Brush BrushDecor
        {
            get { return (Brush)GetValue(BrushDecorProperty); }
            set { SetValue(BrushDecorProperty, value); }
        }

        // Using a DependencyProperty as the backing store for BrushDecor.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty BrushDecorProperty =
            DependencyProperty.Register("BrushDecor", typeof(Brush), typeof(LogoShield), new PropertyMetadata(new SolidColorBrush(Colors.Black)));

        public string Text
        {
            get { return (string)GetValue(TextProperty); }
            set { SetValue(TextProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Text.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty TextProperty =
            DependencyProperty.Register("Text", typeof(string), typeof(LogoShield), new PropertyMetadata("Sistema d'Informació Geogràfica de Catalunya"));

        
    }
}
