﻿using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;

namespace Sigcat.Client.Views.WpfWindows.Resources
{
    /// <summary>
    /// Lógica de interacción para Escut_Generalitat.xaml
    /// </summary>
    public partial class Shield : UserControl//, INotifyPropertyChanged
    {
        public Shield()
        {
            InitializeComponent();
        }

        public Brush BrushShield
        {
            get { return (Brush)GetValue(BrushShieldProperty); }
            set { SetValue(BrushShieldProperty, value); }
        }

        // Using a DependencyProperty as the backing store for BrushShield.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty BrushShieldProperty =
            DependencyProperty.Register("BrushShield", typeof(Brush), typeof(Shield), new PropertyMetadata(new SolidColorBrush(Color.FromRgb(255, 230, 16))));

        public Brush BrushBar
        {
            get { return (Brush)GetValue(BrushBarProperty); }
            set { SetValue(BrushBarProperty, value); }
        }

        // Using a DependencyProperty as the backing store for BrushBar.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty BrushBarProperty =
            DependencyProperty.Register("BrushBar", typeof(Brush), typeof(Shield), new PropertyMetadata(new SolidColorBrush(Color.FromRgb(228, 27, 19))));

        public Brush BrushBorder
        {
            get { return (Brush)GetValue(BrushBorderProperty); }
            set { SetValue(BrushBorderProperty, value); }
        }

        // Using a DependencyProperty as the backing store for BrushBorder.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty BrushBorderProperty =
            DependencyProperty.Register("BrushBorder", typeof(Brush), typeof(Shield), new PropertyMetadata(new SolidColorBrush(Colors.Black)));

        public Brush BrushDecor
        {
            get { return (Brush)GetValue(BrushDecorProperty); }
            set { SetValue(BrushDecorProperty, value); }
        }

        // Using a DependencyProperty as the backing store for BrushDecor.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty BrushDecorProperty =
            DependencyProperty.Register("BrushDecor", typeof(Brush), typeof(Shield), new PropertyMetadata(new SolidColorBrush(Colors.Black)));

        

        //#region Property BrushShield

        ///// <summary>El camp privat <c>_BrushShield</c> representa el color de fons de l'escut.</summary>
        ///// <value>Valor de tipus <c>Brush</c>.</value>
        ///// <remarks>Color groc per defecte al fons de l'escut.</remarks>
        //private Brush _BrushShield = new SolidColorBrush(Color.FromRgb(255, 230, 16));

        ///// <summary>La propietat <c>BrushShield</c> representa el color de fons de l'escut.</summary> 
        ///// <value>La propietat <c>BrushShield</c> obté/estableix el valor de tipus <c>Brush</c> del camp <c>_BrushShield</c>.</value> 
        //public Brush BrushShield
        //{
        //    get { return _BrushShield; }
        //    set
        //    {
        //        // s'estableix el valor només si hi ha canvi de valor
        //        if (_BrushShield == value)
        //            return;
        //        // s'estableix el valor al camp de la propietat
        //        _BrushShield = value;
        //        // es crida l'event PropertyChanged de INotifyPropertyChanged
        //        this.OnPropertyChanged("BrushShield");
        //    }
        //}

        //#endregion
        
        //#region Property BrushBar

        ///// <summary>El camp privat <c>_BrushBar</c> representa el color de les quatre barres.</summary>
        ///// <value>Valor de tipus <c>Brush</c>.</value>
        ///// <remarks>Color vermell per defecte a les barres.</remarks>
        //private Brush _BrushBar = new SolidColorBrush(Color.FromRgb(228, 27, 19));

        ///// <summary>La propietat <c>BrushBar</c> representa el color de les quatre barres.</summary> 
        ///// <value>La propietat <c>BrushBar</c> obté/estableix el valor de tipus <c>Brush</c> del camp <c>_BrushBar</c>.</value> 
        //[DefaultValue("#E41B13")]
        //public Brush BrushBar
        //{
        //    get { return _BrushBar; }
        //    set
        //    {
        //        // s'estableix el valor només si hi ha canvi de valor
        //        if (_BrushBar == value)
        //            return;
        //        // s'estableix el valor al camp de la propietat
        //        _BrushBar = value;
        //        // es crida l'event PropertyChanged de INotifyPropertyChanged
        //        this.OnPropertyChanged("BrushBar");
        //    }
        //}

        //#endregion

        //#region Property BrushBorder

        ///// <summary>El camp privat <c>_BrushBorder</c> representa el color del marc de l'escut.</summary>
        ///// <value>Valor de tipus <c>Brush</c>.</value>
        ///// <remarks>Color negre per defecte al marc de l'escut.</remarks>
        //private Brush _BrushBorder = new SolidColorBrush(Colors.Black);

        ///// <summary>La propietat <c>BrushBorder</c> representa el color del marc de l'escut.</summary> 
        ///// <value>La propietat <c>BrushBorder</c> obté/estableix el valor de tipus <c>Brush</c> del camp <c>_BrushBorder</c>.</value> 
        //public Brush BrushBorder
        //{
        //    get { return _BrushBorder; }
        //    set
        //    {
        //        // s'estableix el valor només si hi ha canvi de valor
        //        if (_BrushBorder == value)
        //            return;
        //        // s'estableix el valor al camp de la propietat
        //        _BrushBorder = value;
        //        // es crida l'event PropertyChanged de INotifyPropertyChanged
        //        this.OnPropertyChanged("BrushBorder");
        //    }
        //}

        //#endregion

        //#region Property BrushDecor

        ///// <summary>El camp privat <c>_BrushDecor</c> representa el color de la decoració de l'escut.</summary>
        ///// <value>Valor de tipus <c>Brush</c>.</value>
        ///// <remarks>Color negre per defecte a la decoració de l'escut.</remarks>
        //private Brush _BrushDecor = new SolidColorBrush(Colors.Black);

        ///// <summary>La propietat <c>BrushDecor</c> representa el color de la decoració de l'escut.</summary> 
        ///// <value>La propietat <c>BrushDecor</c> obté/estableix el valor de tipus <c>Brush</c> del camp <c>_BrushDecor</c>.</value> 
        //public Brush BrushDecor
        //{
        //    get { return _BrushDecor; }
        //    set
        //    {
        //        // s'estableix el valor només si hi ha canvi de valor
        //        if (_BrushDecor == value)
        //            return;
        //        // s'estableix el valor al camp de la propietat
        //        _BrushDecor = value;
        //        // es crida l'event PropertyChanged de INotifyPropertyChanged
        //        this.OnPropertyChanged("BrushDecor");
        //    }
        //}

        //#endregion

        //#region INotifyPropertyChanged

        //public event PropertyChangedEventHandler PropertyChanged;

        //// Create the OnPropertyChanged method to raise the event
        //protected void OnPropertyChanged(string name)
        //{
        //    PropertyChangedEventHandler handler = PropertyChanged;
        //    if (handler != null)
        //    {
        //        handler(this, new PropertyChangedEventArgs(name));
        //    }
        //}

        //#endregion

    }
}
