﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Sigcat.Client.Views.WpfWindows.View
{
    /// <summary>
    /// Lógica de interacción para SessionView.xaml
    /// </summary>
    public partial class SessionView : UserControl
    {

        public string UserName
        {
            get { return (string)GetValue(UserNameProperty); }
            set { SetValue(UserNameProperty, value); }
        }

        // Using a DependencyProperty as the backing store for UserName.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty UserNameProperty =
            DependencyProperty.Register("UserName", typeof(string), typeof(SessionView), new PropertyMetadata("Anònim"));

        public bool IsLogon
        {
            get { return (bool)GetValue(IsLogonProperty); }
            set { SetValue(IsLogonProperty, value); }
        }

        // Using a DependencyProperty as the backing store for IsLogon.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty IsLogonProperty =
            DependencyProperty.Register("IsLogon", typeof(bool), typeof(SessionView), new PropertyMetadata(false));

        public SessionView()
        {
            InitializeComponent();
            UserName = "Anònim";
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            LoginView login = new LoginView(this);
            Window win = Application.Current.MainWindow;
            login.Owner = win;
            login.ShowDialog();
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            UserName = "Anònim";
            IsLogon = false;
        }
    }
}
