
-- --------------------------------------------------
-- Entity Designer DDL Script for SQL Server 2005, 2008, and Azure
-- --------------------------------------------------
-- Date Created: 05/23/2013 00:27:13
-- Generated from EDMX file: G:\Development\Sigcat\Sigcat.Solution\Sigcat.Server\Model\SigcatModel.edmx
-- --------------------------------------------------

SET QUOTED_IDENTIFIER OFF;
GO
USE [SigcatDB];
GO
IF SCHEMA_ID(N'dbo') IS NULL EXECUTE(N'CREATE SCHEMA [dbo]');
GO

-- --------------------------------------------------
-- Dropping existing FOREIGN KEY constraints
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[FK_AuditAuditField]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[AuditFields] DROP CONSTRAINT [FK_AuditAuditField];
GO
IF OBJECT_ID(N'[dbo].[FK_BuildingBuildingType_Buildings]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[BuildingBuildingType] DROP CONSTRAINT [FK_BuildingBuildingType_Buildings];
GO
IF OBJECT_ID(N'[dbo].[FK_BuildingBuildingType_BuildingTypes]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[BuildingBuildingType] DROP CONSTRAINT [FK_BuildingBuildingType_BuildingTypes];
GO
IF OBJECT_ID(N'[dbo].[FK_BuildingTypeOrgan]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Organs] DROP CONSTRAINT [FK_BuildingTypeOrgan];
GO
IF OBJECT_ID(N'[dbo].[FK_DirectorateBuildingType]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[BuildingTypes] DROP CONSTRAINT [FK_DirectorateBuildingType];
GO
IF OBJECT_ID(N'[dbo].[FK_DirectorateMapLayer_Directorates]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[DirectorateMapLayer] DROP CONSTRAINT [FK_DirectorateMapLayer_Directorates];
GO
IF OBJECT_ID(N'[dbo].[FK_DirectorateMapLayer_MapLayers]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[DirectorateMapLayer] DROP CONSTRAINT [FK_DirectorateMapLayer_MapLayers];
GO
IF OBJECT_ID(N'[dbo].[FK_DirectorateOrganType]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[OrganTypes] DROP CONSTRAINT [FK_DirectorateOrganType];
GO
IF OBJECT_ID(N'[dbo].[FK_DirectorateUser]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Users] DROP CONSTRAINT [FK_DirectorateUser];
GO
IF OBJECT_ID(N'[dbo].[FK_FillSymbol_inherits_Symbol]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Symbols_FillSymbol] DROP CONSTRAINT [FK_FillSymbol_inherits_Symbol];
GO
IF OBJECT_ID(N'[dbo].[FK_IdentityUser]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Users] DROP CONSTRAINT [FK_IdentityUser];
GO
IF OBJECT_ID(N'[dbo].[FK_LineSymbol_inherits_Symbol]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Symbols_LineSymbol] DROP CONSTRAINT [FK_LineSymbol_inherits_Symbol];
GO
IF OBJECT_ID(N'[dbo].[FK_MapLayerMapShape]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[MapShapes] DROP CONSTRAINT [FK_MapLayerMapShape];
GO
IF OBJECT_ID(N'[dbo].[FK_MapShapeMapShape]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[MapShapes] DROP CONSTRAINT [FK_MapShapeMapShape];
GO
IF OBJECT_ID(N'[dbo].[FK_MapShapeOrgan]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Organs] DROP CONSTRAINT [FK_MapShapeOrgan];
GO
IF OBJECT_ID(N'[dbo].[FK_MarkerSymbol_inherits_Symbol]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Symbols_MarkerSymbol] DROP CONSTRAINT [FK_MarkerSymbol_inherits_Symbol];
GO
IF OBJECT_ID(N'[dbo].[FK_OgcGroupOgcGroup]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[OgcGroups] DROP CONSTRAINT [FK_OgcGroupOgcGroup];
GO
IF OBJECT_ID(N'[dbo].[FK_OgcGroupOgcLayer]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[OgcLayers] DROP CONSTRAINT [FK_OgcGroupOgcLayer];
GO
IF OBJECT_ID(N'[dbo].[FK_Organization_inherits_Identity]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Identities_Organization] DROP CONSTRAINT [FK_Organization_inherits_Identity];
GO
IF OBJECT_ID(N'[dbo].[FK_OrganOrgan]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Organs] DROP CONSTRAINT [FK_OrganOrgan];
GO
IF OBJECT_ID(N'[dbo].[FK_OrganPoiLayer]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[PoiLayers] DROP CONSTRAINT [FK_OrganPoiLayer];
GO
IF OBJECT_ID(N'[dbo].[FK_OrganTypeOrgan]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Organs] DROP CONSTRAINT [FK_OrganTypeOrgan];
GO
IF OBJECT_ID(N'[dbo].[FK_OrganUser]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Users] DROP CONSTRAINT [FK_OrganUser];
GO
IF OBJECT_ID(N'[dbo].[FK_Person_inherits_Identity]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Identities_Person] DROP CONSTRAINT [FK_Person_inherits_Identity];
GO
IF OBJECT_ID(N'[dbo].[FK_PersonIdentityCard]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[IdentityCards] DROP CONSTRAINT [FK_PersonIdentityCard];
GO
IF OBJECT_ID(N'[dbo].[FK_PictureSymbol_inherits_Symbol]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Symbols_PictureSymbol] DROP CONSTRAINT [FK_PictureSymbol_inherits_Symbol];
GO
IF OBJECT_ID(N'[dbo].[FK_PoiLayerPoiShape]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[PoiShapes] DROP CONSTRAINT [FK_PoiLayerPoiShape];
GO
IF OBJECT_ID(N'[dbo].[FK_RoleOrgan]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Organs] DROP CONSTRAINT [FK_RoleOrgan];
GO
IF OBJECT_ID(N'[dbo].[FK_Unowned_inherits_Identity]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Identities_Unowned] DROP CONSTRAINT [FK_Unowned_inherits_Identity];
GO
IF OBJECT_ID(N'[dbo].[FK_UserMembership]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[Memberships] DROP CONSTRAINT [FK_UserMembership];
GO

-- --------------------------------------------------
-- Dropping existing tables
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[AuditFields]', 'U') IS NOT NULL
    DROP TABLE [dbo].[AuditFields];
GO
IF OBJECT_ID(N'[dbo].[Audits]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Audits];
GO
IF OBJECT_ID(N'[dbo].[BuildingBuildingType]', 'U') IS NOT NULL
    DROP TABLE [dbo].[BuildingBuildingType];
GO
IF OBJECT_ID(N'[dbo].[Buildings]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Buildings];
GO
IF OBJECT_ID(N'[dbo].[BuildingTypes]', 'U') IS NOT NULL
    DROP TABLE [dbo].[BuildingTypes];
GO
IF OBJECT_ID(N'[dbo].[DirectorateMapLayer]', 'U') IS NOT NULL
    DROP TABLE [dbo].[DirectorateMapLayer];
GO
IF OBJECT_ID(N'[dbo].[Directorates]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Directorates];
GO
IF OBJECT_ID(N'[dbo].[Identities]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Identities];
GO
IF OBJECT_ID(N'[dbo].[Identities_Organization]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Identities_Organization];
GO
IF OBJECT_ID(N'[dbo].[Identities_Person]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Identities_Person];
GO
IF OBJECT_ID(N'[dbo].[Identities_Unowned]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Identities_Unowned];
GO
IF OBJECT_ID(N'[dbo].[IdentityCards]', 'U') IS NOT NULL
    DROP TABLE [dbo].[IdentityCards];
GO
IF OBJECT_ID(N'[dbo].[MapLayers]', 'U') IS NOT NULL
    DROP TABLE [dbo].[MapLayers];
GO
IF OBJECT_ID(N'[dbo].[MapShapes]', 'U') IS NOT NULL
    DROP TABLE [dbo].[MapShapes];
GO
IF OBJECT_ID(N'[dbo].[Memberships]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Memberships];
GO
IF OBJECT_ID(N'[dbo].[OgcGroups]', 'U') IS NOT NULL
    DROP TABLE [dbo].[OgcGroups];
GO
IF OBJECT_ID(N'[dbo].[OgcLayers]', 'U') IS NOT NULL
    DROP TABLE [dbo].[OgcLayers];
GO
IF OBJECT_ID(N'[dbo].[Organs]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Organs];
GO
IF OBJECT_ID(N'[dbo].[OrganTypes]', 'U') IS NOT NULL
    DROP TABLE [dbo].[OrganTypes];
GO
IF OBJECT_ID(N'[dbo].[PoiLayers]', 'U') IS NOT NULL
    DROP TABLE [dbo].[PoiLayers];
GO
IF OBJECT_ID(N'[dbo].[PoiShapes]', 'U') IS NOT NULL
    DROP TABLE [dbo].[PoiShapes];
GO
IF OBJECT_ID(N'[dbo].[Roles]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Roles];
GO
IF OBJECT_ID(N'[dbo].[Symbols]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Symbols];
GO
IF OBJECT_ID(N'[dbo].[Symbols_FillSymbol]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Symbols_FillSymbol];
GO
IF OBJECT_ID(N'[dbo].[Symbols_LineSymbol]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Symbols_LineSymbol];
GO
IF OBJECT_ID(N'[dbo].[Symbols_MarkerSymbol]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Symbols_MarkerSymbol];
GO
IF OBJECT_ID(N'[dbo].[Symbols_PictureSymbol]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Symbols_PictureSymbol];
GO
IF OBJECT_ID(N'[dbo].[Users]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Users];
GO

-- --------------------------------------------------
-- Creating all tables
-- --------------------------------------------------

-- Creating table 'AuditFields'
CREATE TABLE [dbo].[AuditFields] (
    [AuditFieldId] int IDENTITY(1,1) NOT NULL,
    [AuditId] int  NOT NULL,
    [FieldName] nvarchar(max)  NOT NULL,
    [NewValue] nvarchar(max)  NOT NULL,
    [OldValue] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'Audits'
CREATE TABLE [dbo].[Audits] (
    [AuditId] int IDENTITY(1,1) NOT NULL,
    [PrimaryKeyField] nvarchar(max)  NOT NULL,
    [PrimaryKeyValue] nvarchar(max)  NOT NULL,
    [TableName] nvarchar(max)  NOT NULL,
    [Type] int  NOT NULL,
    [UpdateDate] datetime  NOT NULL,
    [UserName] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'Buildings'
CREATE TABLE [dbo].[Buildings] (
    [BuildingId] int IDENTITY(1,1) NOT NULL,
    [Name] nvarchar(max)  NOT NULL,
    [LocationWKT] nvarchar(max)  NOT NULL,
    [Photo] varbinary(max)  NULL,
    [Comments] nvarchar(max)  NULL
);
GO

-- Creating table 'BuildingTypes'
CREATE TABLE [dbo].[BuildingTypes] (
    [BuildingTypeId] int IDENTITY(1,1) NOT NULL,
    [DirectorateId] int  NOT NULL,
    [Name] nvarchar(max)  NOT NULL,
    [Icon] varbinary(max)  NULL,
    [Comments] nvarchar(max)  NULL
);
GO

-- Creating table 'Directorates'
CREATE TABLE [dbo].[Directorates] (
    [DirectorateId] int IDENTITY(1,1) NOT NULL,
    [Name] nvarchar(max)  NOT NULL,
    [Icon] varbinary(max)  NULL,
    [Comments] nvarchar(max)  NULL
);
GO

-- Creating table 'Identities'
CREATE TABLE [dbo].[Identities] (
    [IdentityId] int IDENTITY(1,1) NOT NULL,
    [Comments] nvarchar(max)  NULL
);
GO

-- Creating table 'IdentityCards'
CREATE TABLE [dbo].[IdentityCards] (
    [IdentityCardId] int IDENTITY(1,1) NOT NULL,
    [IdentityId] int  NOT NULL,
    [Number] nvarchar(max)  NOT NULL,
    [Type] int  NOT NULL
);
GO

-- Creating table 'MapLayers'
CREATE TABLE [dbo].[MapLayers] (
    [MapLayerId] int IDENTITY(1,1) NOT NULL,
    [Name] nvarchar(max)  NOT NULL,
    [Icon] varbinary(max)  NOT NULL,
    [IsLockedOut] bit  NOT NULL,
    [Comments] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'MapShapes'
CREATE TABLE [dbo].[MapShapes] (
    [MapShapeId] int IDENTITY(1,1) NOT NULL,
    [MapLayerId] int  NOT NULL,
    [ParentId] int  NULL,
    [Name] nvarchar(max)  NOT NULL,
    [ShapeWKT] nvarchar(max)  NOT NULL,
    [Comments] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'Memberships'
CREATE TABLE [dbo].[Memberships] (
    [MembershipId] int IDENTITY(1,1) NOT NULL,
    [UserId] int  NOT NULL,
    [Email] nvarchar(max)  NOT NULL,
    [PasswordHash] nvarchar(max)  NOT NULL,
    [PasswordSalt] nvarchar(max)  NOT NULL,
    [PasswordQuestion] nvarchar(max)  NOT NULL,
    [PasswordAnswerHash] nvarchar(max)  NOT NULL,
    [PasswordAnswerSalt] nvarchar(max)  NOT NULL,
    [IsLockedOut] bit  NOT NULL
);
GO

-- Creating table 'OgcGroups'
CREATE TABLE [dbo].[OgcGroups] (
    [OgcGroupId] int IDENTITY(1,1) NOT NULL,
    [ParentId] int  NULL,
    [Name] nvarchar(max)  NOT NULL,
    [IsLockedOut] bit  NOT NULL,
    [Comments] nvarchar(max)  NULL
);
GO

-- Creating table 'OgcLayers'
CREATE TABLE [dbo].[OgcLayers] (
    [OgcLayerId] int IDENTITY(1,1) NOT NULL,
    [OgcGroupId] int  NOT NULL,
    [Name] nvarchar(max)  NOT NULL,
    [Url] nvarchar(max)  NOT NULL,
    [IsLockedOut] bit  NOT NULL,
    [Comments] nvarchar(max)  NULL
);
GO

-- Creating table 'Organs'
CREATE TABLE [dbo].[Organs] (
    [OrganId] int IDENTITY(1,1) NOT NULL,
    [ParentId] int  NULL,
    [OrganTypeId] int  NOT NULL,
    [BuildingTypeId] int  NULL,
    [MapShapeId] int  NULL,
    [RoleId] int  NOT NULL,
    [Name] nvarchar(max)  NOT NULL,
    [Comments] nvarchar(max)  NULL
);
GO

-- Creating table 'OrganTypes'
CREATE TABLE [dbo].[OrganTypes] (
    [OrganTypeId] int IDENTITY(1,1) NOT NULL,
    [DirectorateId] int  NOT NULL,
    [Name] nvarchar(max)  NOT NULL,
    [Icon] varbinary(max)  NULL,
    [Comments] nvarchar(max)  NULL
);
GO

-- Creating table 'PoiLayers'
CREATE TABLE [dbo].[PoiLayers] (
    [PoiLayerId] int IDENTITY(1,1) NOT NULL,
    [OrganId] int  NOT NULL,
    [Name] nvarchar(max)  NOT NULL,
    [Icon] varbinary(max)  NULL,
    [ShapeType] int  NOT NULL,
    [PublicPermission] int  NOT NULL,
    [DirectoratePermission] int  NOT NULL,
    [LocalPermission] int  NOT NULL
);
GO

-- Creating table 'PoiShapes'
CREATE TABLE [dbo].[PoiShapes] (
    [PoiShapeId] int IDENTITY(1,1) NOT NULL,
    [PoiLayerId] int  NOT NULL,
    [Name] nvarchar(max)  NOT NULL,
    [ShapeWKT] nvarchar(max)  NOT NULL,
    [Comments] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'Roles'
CREATE TABLE [dbo].[Roles] (
    [RoleId] int IDENTITY(1,1) NOT NULL,
    [Name] nvarchar(max)  NOT NULL,
    [Comments] nvarchar(max)  NULL
);
GO

-- Creating table 'Symbols'
CREATE TABLE [dbo].[Symbols] (
    [SymbolId] int IDENTITY(1,1) NOT NULL,
    [Name] nvarchar(max)  NOT NULL,
    [Comments] nvarchar(max)  NULL
);
GO

-- Creating table 'Users'
CREATE TABLE [dbo].[Users] (
    [UserId] int IDENTITY(1,1) NOT NULL,
    [IdentityId] int  NOT NULL,
    [DirectorateId] int  NOT NULL,
    [OrganId] int  NOT NULL,
    [UserName] nvarchar(max)  NOT NULL,
    [IsRemoved] bit  NOT NULL,
    [Comments] nvarchar(max)  NULL
);
GO

-- Creating table 'Identities_Person'
CREATE TABLE [dbo].[Identities_Person] (
    [FirstName] nvarchar(max)  NOT NULL,
    [FirstLastName] nvarchar(max)  NOT NULL,
    [SecondLastName] nvarchar(max)  NOT NULL,
    [IdentityId] int  NOT NULL
);
GO

-- Creating table 'Identities_Organization'
CREATE TABLE [dbo].[Identities_Organization] (
    [LegalName] nvarchar(max)  NOT NULL,
    [IdentityId] int  NOT NULL
);
GO

-- Creating table 'Identities_Unowned'
CREATE TABLE [dbo].[Identities_Unowned] (
    [Name] nvarchar(max)  NOT NULL,
    [IdentityId] int  NOT NULL
);
GO

-- Creating table 'Symbols_FillSymbol'
CREATE TABLE [dbo].[Symbols_FillSymbol] (
    [BorderColorARGB] int  NOT NULL,
    [BorderThickness] float  NOT NULL,
    [FillColorARGB] int  NOT NULL,
    [SymbolId] int  NOT NULL
);
GO

-- Creating table 'Symbols_LineSymbol'
CREATE TABLE [dbo].[Symbols_LineSymbol] (
    [ColorARGB] int  NOT NULL,
    [Width] float  NOT NULL,
    [Style] tinyint  NOT NULL,
    [SymbolId] int  NOT NULL
);
GO

-- Creating table 'Symbols_MarkerSymbol'
CREATE TABLE [dbo].[Symbols_MarkerSymbol] (
    [ColorARGB] int  NOT NULL,
    [Size] float  NOT NULL,
    [Style] tinyint  NOT NULL,
    [SymbolId] int  NOT NULL
);
GO

-- Creating table 'Symbols_PictureSymbol'
CREATE TABLE [dbo].[Symbols_PictureSymbol] (
    [Image] varbinary(max)  NOT NULL,
    [Width] float  NOT NULL,
    [Height] float  NOT NULL,
    [Opacity] float  NOT NULL,
    [SymbolId] int  NOT NULL
);
GO

-- Creating table 'BuildingBuildingType'
CREATE TABLE [dbo].[BuildingBuildingType] (
    [Buildings_BuildingId] int  NOT NULL,
    [BuildingTypes_BuildingTypeId] int  NOT NULL
);
GO

-- Creating table 'DirectorateMapLayer'
CREATE TABLE [dbo].[DirectorateMapLayer] (
    [Directorates_DirectorateId] int  NOT NULL,
    [MapLayers_MapLayerId] int  NOT NULL
);
GO

-- --------------------------------------------------
-- Creating all PRIMARY KEY constraints
-- --------------------------------------------------

-- Creating primary key on [AuditFieldId] in table 'AuditFields'
ALTER TABLE [dbo].[AuditFields]
ADD CONSTRAINT [PK_AuditFields]
    PRIMARY KEY CLUSTERED ([AuditFieldId] ASC);
GO

-- Creating primary key on [AuditId] in table 'Audits'
ALTER TABLE [dbo].[Audits]
ADD CONSTRAINT [PK_Audits]
    PRIMARY KEY CLUSTERED ([AuditId] ASC);
GO

-- Creating primary key on [BuildingId] in table 'Buildings'
ALTER TABLE [dbo].[Buildings]
ADD CONSTRAINT [PK_Buildings]
    PRIMARY KEY CLUSTERED ([BuildingId] ASC);
GO

-- Creating primary key on [BuildingTypeId] in table 'BuildingTypes'
ALTER TABLE [dbo].[BuildingTypes]
ADD CONSTRAINT [PK_BuildingTypes]
    PRIMARY KEY CLUSTERED ([BuildingTypeId] ASC);
GO

-- Creating primary key on [DirectorateId] in table 'Directorates'
ALTER TABLE [dbo].[Directorates]
ADD CONSTRAINT [PK_Directorates]
    PRIMARY KEY CLUSTERED ([DirectorateId] ASC);
GO

-- Creating primary key on [IdentityId] in table 'Identities'
ALTER TABLE [dbo].[Identities]
ADD CONSTRAINT [PK_Identities]
    PRIMARY KEY CLUSTERED ([IdentityId] ASC);
GO

-- Creating primary key on [IdentityCardId] in table 'IdentityCards'
ALTER TABLE [dbo].[IdentityCards]
ADD CONSTRAINT [PK_IdentityCards]
    PRIMARY KEY CLUSTERED ([IdentityCardId] ASC);
GO

-- Creating primary key on [MapLayerId] in table 'MapLayers'
ALTER TABLE [dbo].[MapLayers]
ADD CONSTRAINT [PK_MapLayers]
    PRIMARY KEY CLUSTERED ([MapLayerId] ASC);
GO

-- Creating primary key on [MapShapeId] in table 'MapShapes'
ALTER TABLE [dbo].[MapShapes]
ADD CONSTRAINT [PK_MapShapes]
    PRIMARY KEY CLUSTERED ([MapShapeId] ASC);
GO

-- Creating primary key on [MembershipId] in table 'Memberships'
ALTER TABLE [dbo].[Memberships]
ADD CONSTRAINT [PK_Memberships]
    PRIMARY KEY CLUSTERED ([MembershipId] ASC);
GO

-- Creating primary key on [OgcGroupId] in table 'OgcGroups'
ALTER TABLE [dbo].[OgcGroups]
ADD CONSTRAINT [PK_OgcGroups]
    PRIMARY KEY CLUSTERED ([OgcGroupId] ASC);
GO

-- Creating primary key on [OgcLayerId] in table 'OgcLayers'
ALTER TABLE [dbo].[OgcLayers]
ADD CONSTRAINT [PK_OgcLayers]
    PRIMARY KEY CLUSTERED ([OgcLayerId] ASC);
GO

-- Creating primary key on [OrganId] in table 'Organs'
ALTER TABLE [dbo].[Organs]
ADD CONSTRAINT [PK_Organs]
    PRIMARY KEY CLUSTERED ([OrganId] ASC);
GO

-- Creating primary key on [OrganTypeId] in table 'OrganTypes'
ALTER TABLE [dbo].[OrganTypes]
ADD CONSTRAINT [PK_OrganTypes]
    PRIMARY KEY CLUSTERED ([OrganTypeId] ASC);
GO

-- Creating primary key on [PoiLayerId] in table 'PoiLayers'
ALTER TABLE [dbo].[PoiLayers]
ADD CONSTRAINT [PK_PoiLayers]
    PRIMARY KEY CLUSTERED ([PoiLayerId] ASC);
GO

-- Creating primary key on [PoiShapeId] in table 'PoiShapes'
ALTER TABLE [dbo].[PoiShapes]
ADD CONSTRAINT [PK_PoiShapes]
    PRIMARY KEY CLUSTERED ([PoiShapeId] ASC);
GO

-- Creating primary key on [RoleId] in table 'Roles'
ALTER TABLE [dbo].[Roles]
ADD CONSTRAINT [PK_Roles]
    PRIMARY KEY CLUSTERED ([RoleId] ASC);
GO

-- Creating primary key on [SymbolId] in table 'Symbols'
ALTER TABLE [dbo].[Symbols]
ADD CONSTRAINT [PK_Symbols]
    PRIMARY KEY CLUSTERED ([SymbolId] ASC);
GO

-- Creating primary key on [UserId] in table 'Users'
ALTER TABLE [dbo].[Users]
ADD CONSTRAINT [PK_Users]
    PRIMARY KEY CLUSTERED ([UserId] ASC);
GO

-- Creating primary key on [IdentityId] in table 'Identities_Person'
ALTER TABLE [dbo].[Identities_Person]
ADD CONSTRAINT [PK_Identities_Person]
    PRIMARY KEY CLUSTERED ([IdentityId] ASC);
GO

-- Creating primary key on [IdentityId] in table 'Identities_Organization'
ALTER TABLE [dbo].[Identities_Organization]
ADD CONSTRAINT [PK_Identities_Organization]
    PRIMARY KEY CLUSTERED ([IdentityId] ASC);
GO

-- Creating primary key on [IdentityId] in table 'Identities_Unowned'
ALTER TABLE [dbo].[Identities_Unowned]
ADD CONSTRAINT [PK_Identities_Unowned]
    PRIMARY KEY CLUSTERED ([IdentityId] ASC);
GO

-- Creating primary key on [SymbolId] in table 'Symbols_FillSymbol'
ALTER TABLE [dbo].[Symbols_FillSymbol]
ADD CONSTRAINT [PK_Symbols_FillSymbol]
    PRIMARY KEY CLUSTERED ([SymbolId] ASC);
GO

-- Creating primary key on [SymbolId] in table 'Symbols_LineSymbol'
ALTER TABLE [dbo].[Symbols_LineSymbol]
ADD CONSTRAINT [PK_Symbols_LineSymbol]
    PRIMARY KEY CLUSTERED ([SymbolId] ASC);
GO

-- Creating primary key on [SymbolId] in table 'Symbols_MarkerSymbol'
ALTER TABLE [dbo].[Symbols_MarkerSymbol]
ADD CONSTRAINT [PK_Symbols_MarkerSymbol]
    PRIMARY KEY CLUSTERED ([SymbolId] ASC);
GO

-- Creating primary key on [SymbolId] in table 'Symbols_PictureSymbol'
ALTER TABLE [dbo].[Symbols_PictureSymbol]
ADD CONSTRAINT [PK_Symbols_PictureSymbol]
    PRIMARY KEY CLUSTERED ([SymbolId] ASC);
GO

-- Creating primary key on [Buildings_BuildingId], [BuildingTypes_BuildingTypeId] in table 'BuildingBuildingType'
ALTER TABLE [dbo].[BuildingBuildingType]
ADD CONSTRAINT [PK_BuildingBuildingType]
    PRIMARY KEY NONCLUSTERED ([Buildings_BuildingId], [BuildingTypes_BuildingTypeId] ASC);
GO

-- Creating primary key on [Directorates_DirectorateId], [MapLayers_MapLayerId] in table 'DirectorateMapLayer'
ALTER TABLE [dbo].[DirectorateMapLayer]
ADD CONSTRAINT [PK_DirectorateMapLayer]
    PRIMARY KEY NONCLUSTERED ([Directorates_DirectorateId], [MapLayers_MapLayerId] ASC);
GO

-- --------------------------------------------------
-- Creating all FOREIGN KEY constraints
-- --------------------------------------------------

-- Creating foreign key on [AuditId] in table 'AuditFields'
ALTER TABLE [dbo].[AuditFields]
ADD CONSTRAINT [FK_AuditAuditField]
    FOREIGN KEY ([AuditId])
    REFERENCES [dbo].[Audits]
        ([AuditId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_AuditAuditField'
CREATE INDEX [IX_FK_AuditAuditField]
ON [dbo].[AuditFields]
    ([AuditId]);
GO

-- Creating foreign key on [BuildingTypeId] in table 'Organs'
ALTER TABLE [dbo].[Organs]
ADD CONSTRAINT [FK_BuildingTypeOrgan]
    FOREIGN KEY ([BuildingTypeId])
    REFERENCES [dbo].[BuildingTypes]
        ([BuildingTypeId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_BuildingTypeOrgan'
CREATE INDEX [IX_FK_BuildingTypeOrgan]
ON [dbo].[Organs]
    ([BuildingTypeId]);
GO

-- Creating foreign key on [DirectorateId] in table 'BuildingTypes'
ALTER TABLE [dbo].[BuildingTypes]
ADD CONSTRAINT [FK_DirectorateBuildingType]
    FOREIGN KEY ([DirectorateId])
    REFERENCES [dbo].[Directorates]
        ([DirectorateId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_DirectorateBuildingType'
CREATE INDEX [IX_FK_DirectorateBuildingType]
ON [dbo].[BuildingTypes]
    ([DirectorateId]);
GO

-- Creating foreign key on [DirectorateId] in table 'OrganTypes'
ALTER TABLE [dbo].[OrganTypes]
ADD CONSTRAINT [FK_DirectorateOrganType]
    FOREIGN KEY ([DirectorateId])
    REFERENCES [dbo].[Directorates]
        ([DirectorateId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_DirectorateOrganType'
CREATE INDEX [IX_FK_DirectorateOrganType]
ON [dbo].[OrganTypes]
    ([DirectorateId]);
GO

-- Creating foreign key on [DirectorateId] in table 'Users'
ALTER TABLE [dbo].[Users]
ADD CONSTRAINT [FK_DirectorateUser]
    FOREIGN KEY ([DirectorateId])
    REFERENCES [dbo].[Directorates]
        ([DirectorateId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_DirectorateUser'
CREATE INDEX [IX_FK_DirectorateUser]
ON [dbo].[Users]
    ([DirectorateId]);
GO

-- Creating foreign key on [IdentityId] in table 'Users'
ALTER TABLE [dbo].[Users]
ADD CONSTRAINT [FK_IdentityUser]
    FOREIGN KEY ([IdentityId])
    REFERENCES [dbo].[Identities]
        ([IdentityId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_IdentityUser'
CREATE INDEX [IX_FK_IdentityUser]
ON [dbo].[Users]
    ([IdentityId]);
GO

-- Creating foreign key on [IdentityId] in table 'IdentityCards'
ALTER TABLE [dbo].[IdentityCards]
ADD CONSTRAINT [FK_PersonIdentityCard]
    FOREIGN KEY ([IdentityId])
    REFERENCES [dbo].[Identities_Person]
        ([IdentityId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_PersonIdentityCard'
CREATE INDEX [IX_FK_PersonIdentityCard]
ON [dbo].[IdentityCards]
    ([IdentityId]);
GO

-- Creating foreign key on [MapLayerId] in table 'MapShapes'
ALTER TABLE [dbo].[MapShapes]
ADD CONSTRAINT [FK_MapLayerMapShape]
    FOREIGN KEY ([MapLayerId])
    REFERENCES [dbo].[MapLayers]
        ([MapLayerId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_MapLayerMapShape'
CREATE INDEX [IX_FK_MapLayerMapShape]
ON [dbo].[MapShapes]
    ([MapLayerId]);
GO

-- Creating foreign key on [ParentId] in table 'MapShapes'
ALTER TABLE [dbo].[MapShapes]
ADD CONSTRAINT [FK_MapShapeMapShape]
    FOREIGN KEY ([ParentId])
    REFERENCES [dbo].[MapShapes]
        ([MapShapeId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_MapShapeMapShape'
CREATE INDEX [IX_FK_MapShapeMapShape]
ON [dbo].[MapShapes]
    ([ParentId]);
GO

-- Creating foreign key on [MapShapeId] in table 'Organs'
ALTER TABLE [dbo].[Organs]
ADD CONSTRAINT [FK_MapShapeOrgan]
    FOREIGN KEY ([MapShapeId])
    REFERENCES [dbo].[MapShapes]
        ([MapShapeId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_MapShapeOrgan'
CREATE INDEX [IX_FK_MapShapeOrgan]
ON [dbo].[Organs]
    ([MapShapeId]);
GO

-- Creating foreign key on [UserId] in table 'Memberships'
ALTER TABLE [dbo].[Memberships]
ADD CONSTRAINT [FK_UserMembership]
    FOREIGN KEY ([UserId])
    REFERENCES [dbo].[Users]
        ([UserId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_UserMembership'
CREATE INDEX [IX_FK_UserMembership]
ON [dbo].[Memberships]
    ([UserId]);
GO

-- Creating foreign key on [ParentId] in table 'OgcGroups'
ALTER TABLE [dbo].[OgcGroups]
ADD CONSTRAINT [FK_OgcGroupOgcGroup]
    FOREIGN KEY ([ParentId])
    REFERENCES [dbo].[OgcGroups]
        ([OgcGroupId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_OgcGroupOgcGroup'
CREATE INDEX [IX_FK_OgcGroupOgcGroup]
ON [dbo].[OgcGroups]
    ([ParentId]);
GO

-- Creating foreign key on [OgcGroupId] in table 'OgcLayers'
ALTER TABLE [dbo].[OgcLayers]
ADD CONSTRAINT [FK_OgcGroupOgcLayer]
    FOREIGN KEY ([OgcGroupId])
    REFERENCES [dbo].[OgcGroups]
        ([OgcGroupId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_OgcGroupOgcLayer'
CREATE INDEX [IX_FK_OgcGroupOgcLayer]
ON [dbo].[OgcLayers]
    ([OgcGroupId]);
GO

-- Creating foreign key on [ParentId] in table 'Organs'
ALTER TABLE [dbo].[Organs]
ADD CONSTRAINT [FK_OrganOrgan]
    FOREIGN KEY ([ParentId])
    REFERENCES [dbo].[Organs]
        ([OrganId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_OrganOrgan'
CREATE INDEX [IX_FK_OrganOrgan]
ON [dbo].[Organs]
    ([ParentId]);
GO

-- Creating foreign key on [OrganId] in table 'PoiLayers'
ALTER TABLE [dbo].[PoiLayers]
ADD CONSTRAINT [FK_OrganPoiLayer]
    FOREIGN KEY ([OrganId])
    REFERENCES [dbo].[Organs]
        ([OrganId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_OrganPoiLayer'
CREATE INDEX [IX_FK_OrganPoiLayer]
ON [dbo].[PoiLayers]
    ([OrganId]);
GO

-- Creating foreign key on [OrganTypeId] in table 'Organs'
ALTER TABLE [dbo].[Organs]
ADD CONSTRAINT [FK_OrganTypeOrgan]
    FOREIGN KEY ([OrganTypeId])
    REFERENCES [dbo].[OrganTypes]
        ([OrganTypeId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_OrganTypeOrgan'
CREATE INDEX [IX_FK_OrganTypeOrgan]
ON [dbo].[Organs]
    ([OrganTypeId]);
GO

-- Creating foreign key on [OrganId] in table 'Users'
ALTER TABLE [dbo].[Users]
ADD CONSTRAINT [FK_OrganUser]
    FOREIGN KEY ([OrganId])
    REFERENCES [dbo].[Organs]
        ([OrganId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_OrganUser'
CREATE INDEX [IX_FK_OrganUser]
ON [dbo].[Users]
    ([OrganId]);
GO

-- Creating foreign key on [RoleId] in table 'Organs'
ALTER TABLE [dbo].[Organs]
ADD CONSTRAINT [FK_RoleOrgan]
    FOREIGN KEY ([RoleId])
    REFERENCES [dbo].[Roles]
        ([RoleId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_RoleOrgan'
CREATE INDEX [IX_FK_RoleOrgan]
ON [dbo].[Organs]
    ([RoleId]);
GO

-- Creating foreign key on [PoiLayerId] in table 'PoiShapes'
ALTER TABLE [dbo].[PoiShapes]
ADD CONSTRAINT [FK_PoiLayerPoiShape]
    FOREIGN KEY ([PoiLayerId])
    REFERENCES [dbo].[PoiLayers]
        ([PoiLayerId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_PoiLayerPoiShape'
CREATE INDEX [IX_FK_PoiLayerPoiShape]
ON [dbo].[PoiShapes]
    ([PoiLayerId]);
GO

-- Creating foreign key on [Buildings_BuildingId] in table 'BuildingBuildingType'
ALTER TABLE [dbo].[BuildingBuildingType]
ADD CONSTRAINT [FK_BuildingBuildingType_Buildings]
    FOREIGN KEY ([Buildings_BuildingId])
    REFERENCES [dbo].[Buildings]
        ([BuildingId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;
GO

-- Creating foreign key on [BuildingTypes_BuildingTypeId] in table 'BuildingBuildingType'
ALTER TABLE [dbo].[BuildingBuildingType]
ADD CONSTRAINT [FK_BuildingBuildingType_BuildingTypes]
    FOREIGN KEY ([BuildingTypes_BuildingTypeId])
    REFERENCES [dbo].[BuildingTypes]
        ([BuildingTypeId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_BuildingBuildingType_BuildingTypes'
CREATE INDEX [IX_FK_BuildingBuildingType_BuildingTypes]
ON [dbo].[BuildingBuildingType]
    ([BuildingTypes_BuildingTypeId]);
GO

-- Creating foreign key on [Directorates_DirectorateId] in table 'DirectorateMapLayer'
ALTER TABLE [dbo].[DirectorateMapLayer]
ADD CONSTRAINT [FK_DirectorateMapLayer_Directorates]
    FOREIGN KEY ([Directorates_DirectorateId])
    REFERENCES [dbo].[Directorates]
        ([DirectorateId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;
GO

-- Creating foreign key on [MapLayers_MapLayerId] in table 'DirectorateMapLayer'
ALTER TABLE [dbo].[DirectorateMapLayer]
ADD CONSTRAINT [FK_DirectorateMapLayer_MapLayers]
    FOREIGN KEY ([MapLayers_MapLayerId])
    REFERENCES [dbo].[MapLayers]
        ([MapLayerId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_DirectorateMapLayer_MapLayers'
CREATE INDEX [IX_FK_DirectorateMapLayer_MapLayers]
ON [dbo].[DirectorateMapLayer]
    ([MapLayers_MapLayerId]);
GO

-- Creating foreign key on [IdentityId] in table 'Identities_Person'
ALTER TABLE [dbo].[Identities_Person]
ADD CONSTRAINT [FK_Person_inherits_Identity]
    FOREIGN KEY ([IdentityId])
    REFERENCES [dbo].[Identities]
        ([IdentityId])
    ON DELETE CASCADE ON UPDATE NO ACTION;
GO

-- Creating foreign key on [IdentityId] in table 'Identities_Organization'
ALTER TABLE [dbo].[Identities_Organization]
ADD CONSTRAINT [FK_Organization_inherits_Identity]
    FOREIGN KEY ([IdentityId])
    REFERENCES [dbo].[Identities]
        ([IdentityId])
    ON DELETE CASCADE ON UPDATE NO ACTION;
GO

-- Creating foreign key on [IdentityId] in table 'Identities_Unowned'
ALTER TABLE [dbo].[Identities_Unowned]
ADD CONSTRAINT [FK_Unowned_inherits_Identity]
    FOREIGN KEY ([IdentityId])
    REFERENCES [dbo].[Identities]
        ([IdentityId])
    ON DELETE CASCADE ON UPDATE NO ACTION;
GO

-- Creating foreign key on [SymbolId] in table 'Symbols_FillSymbol'
ALTER TABLE [dbo].[Symbols_FillSymbol]
ADD CONSTRAINT [FK_FillSymbol_inherits_Symbol]
    FOREIGN KEY ([SymbolId])
    REFERENCES [dbo].[Symbols]
        ([SymbolId])
    ON DELETE CASCADE ON UPDATE NO ACTION;
GO

-- Creating foreign key on [SymbolId] in table 'Symbols_LineSymbol'
ALTER TABLE [dbo].[Symbols_LineSymbol]
ADD CONSTRAINT [FK_LineSymbol_inherits_Symbol]
    FOREIGN KEY ([SymbolId])
    REFERENCES [dbo].[Symbols]
        ([SymbolId])
    ON DELETE CASCADE ON UPDATE NO ACTION;
GO

-- Creating foreign key on [SymbolId] in table 'Symbols_MarkerSymbol'
ALTER TABLE [dbo].[Symbols_MarkerSymbol]
ADD CONSTRAINT [FK_MarkerSymbol_inherits_Symbol]
    FOREIGN KEY ([SymbolId])
    REFERENCES [dbo].[Symbols]
        ([SymbolId])
    ON DELETE CASCADE ON UPDATE NO ACTION;
GO

-- Creating foreign key on [SymbolId] in table 'Symbols_PictureSymbol'
ALTER TABLE [dbo].[Symbols_PictureSymbol]
ADD CONSTRAINT [FK_PictureSymbol_inherits_Symbol]
    FOREIGN KEY ([SymbolId])
    REFERENCES [dbo].[Symbols]
        ([SymbolId])
    ON DELETE CASCADE ON UPDATE NO ACTION;
GO

-- --------------------------------------------------
-- Script has ended
-- --------------------------------------------------