﻿using Sigcat.Server.Helpers;
using Sigcat.Server.Model;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.DomainServices.EntityFramework;
using System.ServiceModel.DomainServices.Hosting;
using System.ServiceModel.DomainServices.Server;

namespace Sigcat.Server.WcfSvcLib
{

    // Implementa la lógica de la aplicación mediante el contexto SigcatEntities.
    // TODO: agregue la lógica de su aplicación a estos métodos o en métodos adicionales.
    // TODO: aplique la autenticación (Windows/ASP.NET Forms) y quite las marcas de comentario de lo siguiente para deshabilitar el acceso anónimo
    // Considere además la posibilidad de agregar roles para restringir el acceso según necesidad.
    // [RequiresAuthentication]
    [EnableClientAccess()]
    public class DomSvc : LinqToEntitiesDomainService<SigcatEntities>, ITestService
    {

        #region ITestService implementation

        /// <summary>
        /// Verifica que el servei web és correcte.
        /// Serveix per realitzar proves de connexió.
        /// </summary>
        /// <returns>
        /// Un objecte <see cref="TestServiceResult"/>
        /// que confirma que s'ha realitzat la connexió.
        /// </returns>
        public TestServiceResult Test()
        {
            var result = new TestServiceResult()
            {
                ServiceName = this.GetType().Name,
                Tested = true
            };
            return result;
        }

        #endregion

        public IQueryable<User> GenerateSampleDatabase()
        {
            string[] tableNames = new string[] { "Memberships", "Users", "IdentityCards", "Identities_Person", "Identities", "Organs", "Roles", "OrganTypes", "Directorates" };
            string[] directorateNames = new string[]
            {
                "Direcció General de la Policia",
                "Direcció General d'Administració de Seguretat",
                "Direcció General de Prevenció, Extinció d'Incendis i Salvaments",
                "Direcció General de Protecció Civil"
            };
            int organs = 15, usuaris = 200;
            string[] organTypeNames = new string[]
            {
                "Direcció General",
                "Gestors",
                "Òrgan",
            };
            string organTypeDG = organTypeNames[0], organTypeManagers = organTypeNames[1], organTypeGeneric = organTypeNames[2];
            string[] roleNames = new string[]
            {
                "Administrator",
                "Manager",
                "MapMaker",
                "Registered"
            };
            string roleAdministrator = roleNames[0], roleManager = roleNames[1], roleMapMaker = roleNames[2];

            string[] firstNames = new string[] { "Adalbert", "Adrià", "Agnès", "Agustí", "Alba", "Albert", "Alexandre", "Aleix", "Àlex", "Alfred", "Alícia", "Àlvar", "Anasti", "Anna", "Andreu", "Àngel", "Àngels", "Antoni", "Antonia", "Ariadna", "Arnau", "Artur", "Assunpció", "August", "Bartomeu", "Bernabè", "Bernardí", "Benvingut", "Bernard", "Bernat", "Beatriu", "Berta", "Biel", "Blai", "Bonaventura", "Caetà", "Camil", "Carla", "Carles", "Carme", "Carolina", "Carlota", "Cast", "Caterina", "Celestí", "Cèsar", "Cipria", "Clara", "Climent", "Constantí", "Cosme", "Cristina", "Cristià", "Cristofor", "Cristofol", "David", "Diana", "Dídac", "Dolors", "Domènec", "Donat", "Eduard", "Eliseu", "Elvira", "Emma", "Emili", "Emília", "Enric", "Ernest", "Esteve", "Estel", "Ester", "Eulàlia", "Fàtima", "Fidel", "Felicitat", "Feliu", "Felip", "Fermí", "Ferran", "Francesc", "Francesca", "Frederic", "Fructuós", "Gabriel", "Gerard", "Gonçal", "Gregori", "Guifré", "Guillem", "Hèctor", "Helena", "Heribert", "Higini", "Hipolit", "Honorat", "Hug", "Ignasi", "Immaculada", "Ireneu", "Iris", "Isabel", "Isidre", "Ivan", "Jacint", "Jaume", "Jeroni", "Joaquim", "Joel", "Jordi", "Josep", "Josepa", "Joan", "Joana", "Julià", "Júlia", "Judit", "Laia", "Lleó", "Lídia", "Llura", "Llorenç", "Luc", "Lluç", "Llúcia", "Lluís", "Lluïsa", "Lorda", "Magdalena", "Manel", "Marc", "Marçal", "Marcel", "Maria", "Mariona", "Marta", "Mateu", "Martí", "Maurici", "Mercè", "Mateu", "Maties", "Maurici", "Màxim", "Miquel", "Miquela", "Mireia", "Mònica", "Monserrat", "Montse", "Narcís", "Natàlia", "Neus", "Nicolau", "Nil", "Núria", "Oleguer", "Oriol", "Òscar", "Olga", "Pau", "Pasqual", "Paula", "Patrícia", "Pelai", "Pere", "Penèlope", "Pilar", "Pius", "Pol", "Ponç", "Prudenci", "Queralt", "Ramon", "Raquel", "Raül", "Regina", "Remei", "Ricard", "Rita", "Robert", "Roderic", "Roc", "Roger", "Rosa", "Roser", "Sanç", "Sebastià", "Segon", "Serafí", "Sergi", "Sever", "Severí", "Sílvia", "Simó", "Simeó", "Sixt", "Sofia", "Sònia", "Susanna", "Teresa", "Tecla", "Tomàs", "Valentí", "Veleri", "Valèria", "Vicent", "Vicenç", "Víctor", "Victòria", "Xavier", "Zacaries" };
            string[] lastNames = new string[] { "Abadal", "Adell", "Adserà", "Aguiló", "Agulló", "Aiats", "Aiguader", "Aiguasenosa", "Aiguaviva", "Aimamí", "Aixalà", "Alabau", "Alamà", "Alanis", "Albaigès", "Albiol", "Alboquers", "Alcover", "Alemany", "Alentorn", "Alenyar", "Ales", "Alimbau", "Aliu", "Almató", "Almirall", "Alomar", "Altaió", "Alzina", "Amades", "Amalaric", "Amill", "Amorós", "Anell", "Anglada", "Anglasell", "Anglès", "Antonijoan", "Aragall", "Arasa", "Arcarons", "Archs", "Ardiaca", "Areny", "Argemí", "Argent", "Argelaguet", "Argilaguet", "Aribau", "Arimany", "Armendares", "Armengol", "Armengou", "Arnal", "Arnau", "Arnó", "Arquer", "Arquilluer", "Arquimbau", "Arrufat", "Artigues", "Artís", "Arumí", "Arxer", "Astruells", "Auger", "Aulèstia", "Aumatell", "Auquer", "Ausàs", "Babot", "Badell", "Bacardit", "Bach", "Bachs", "Badenes", "Badia", "Badó", "Baig", "Baixench", "Balenes", "Balenyà", "Ballester", "Bancells", "Banosa", "Banyuls", "Baradot", "Bareny", "Barnils", "Baró", "Barraquer", "Barrera", "Barrufet", "Bas", "Bassegoda", "Bassó", "Bastardes", "Batet", "Batlle", "Batllori", "Bech", "Bechdejú", "Bel", "Bellprat", "Belluga", "Bellvehí", "Beltran", "Benach", "Benavent", "Benejam", "Benetó", "Bennàsser", "Bertran", "Bertranpetit", "Bertrolich", "Besaluch", "Besora", "Betí", "Bilbeny", "Billabriga", "Billés", "Blader", "Blanquer", "Bleda", "Bofarull", "Bofill", "Bohigues", "Boira", "Boix", "Boixaderes", "Boixadós", "Boixeda", "Boloix", "Bolufer", "Bonadona", "Bonal", "Bonamusa", "Bonany", "Bondia", "Bonet", "Bonjoch", "Bonnín", "Bonshoms", "Borbó", "Bori", "Borrell", "Bosc", "Bosquets", "Botifoll", "Bou", "Bover", "Bracons", "Bragulat", "Bressolí", "Bricall", "Brocà", "Brossa", "Brotons", "Brugats", "Brugatsdamunt", "Brugatsdavall", "Bruguera", "Brugulat", "Buch", "Buisac", "Bujons", "Bullich", "Cabanyes", "Cadafalch", "Cairell", "Calabuig", "Calafí", "Calbó", "Calders", "Callau", "Callicó", "Callís", "Callol", "Calsapeu", "Calvell", "Calvet", "Camafreita", "Camardons", "Camats", "Cambó", "Camilleri", "Camós", "Camp", "Campabadal", "Campalans", "Campdedéu", "Campdepadrós", "Campolier", "Campreciós", "Camprubí", "Camps", "Canadell", "Candi", "Canelies", "Canelles", "Canes", "Cantons", "Canturri", "Canut", "Canyadell", "Canyelles", "Capell", "Capellà", "Capmany", "Carandell", "Carbó", "Carbonell", "Cardellach", "Cardó", "Cardús", "Cargol", "Carner", "Carol", "Carolà", "Carratalà", "Carret", "Carreres", "Casadellà", "Casademunt", "Casadesús", "Casadevall", "Casajoana", "Casamitjana", "Casanelles", "Casanova", "Casals", "Casasses", "Casasús", "Caselles", "Caseny", "Cases", "Cassany", "Cassi", "Castany", "Castanyer", "Castell", "Castellarnau", "Castellet", "Castellot", "Castells", "Castellseguí", "Castelltort", "Castellví", "Català", "Catarineu", "Cateura", "Cava", "Cavaller", "Celis", "Cerveró", "Cirera", "Cirici", "Cisa", "Civanyan", "Civit", "Civis", "Claris", "Clavell", "Clofent", "Clop", "Clos", "Closella", "Clot", "Clotet", "Coca", "Codina", "Codonyan", "Coll", "Collbatalló", "Colldeforns", "Colldelram", "Collell", "Collelldemont", "Collmer", "Colom", "Colomer", "Cols", "Coma", "Comadran", "Comalat", "Comamala", "Comaposada", "Comes", "Comerma", "Comí", "Comorera", "Companys", "Compte", "Conill", "Conillera", "Conte", "Corb", "Corcoll", "Cordonet", "Cornet", "Coroleu", "Corredor", "Corretja", "Cors", "Cortada", "Cortès", "Cosidor", "Costa", "Cots", "Creixells", "Cresques", "Crossa", "Crosses", "Cruanyes", "Cruells", "Cucarella", "Cucurull", "Cuní", "Curull", "Cussó", "Dalmau", "Dardanyà", "Darder", "Daurella", "Daviu", "Dedéu", "Defilló", "Delclòs", "Delort", "Damians", "Dencàs", "Descàrrega", "Desumbila", "Desvalls", "Deu", "Deugràcies", "Deulofeu", "Dinarès", "Dolcet", "Dolç", "Dot", "Dunyol", "Duocastella", "Durany", "Eiximenis", "Ensenyat", "Escaiol", "Escandell", "Escarcella", "Esclasans", "Escofet", "Escòlies", "Escorcell", "Escrig", "Escrivà", "Espar", "Espelt", "Espinalt", "Espinars", "Espriu", "Esquirol", "Estalrich", "Estanyol", "Fabra", "Fabregat", "Fabregó", "Fàbregues", "Faiadell", "Fandos", "Farell", "Farinyes", "Farners", "Farriols", "Fau", "Faulí", "Fenollar", "Fermat", "Ferrà", "Ferràs", "Ferrandis", "Fibla", "Filella", "Fiter", "Fiveller", "Flequer", "Florensa", "Flotats", "Fluxa", "Foix", "Folch", "Fonoll", "Fonollà", "Fontanals", "Fontbernat", "Fontbona", "Fontova", "Fontserè", "Forcada", "Forcadell", "Formatger", "Formiguera", "Fortesa", "Franch", "Fransitorra", "Freixanet", "Freixes", "Frisach", "Fullà", "Fullana", "Fullat", "Furió", "Fuster", "Gabarró", "Gai", "Gaixet", "Gaja", "Gaju", "Galí", "Gallart", "Gallissà", "Gallofrer", "Galvany", "Gamell", "Gamonal", "Ganyet", "Garangou", "Garreta", "Garrell", "Garrigosa", "Garsaball", "Gasull", "Gatell", "Gateu", "Gaudí", "Gavaldà", "Gelats", "Gendrau", "Gener", "Germà", "Gili", "Gilibets", "Gilisbarts", "Gimbernau", "Ginebreda", "Giner", "Giraut", "Gispert", "Gistau", "Gol", "Golferich", "Gols", "Gombau", "Gomis", "Gonfaus", "Gonyalons", "Gorguí", "Gorina", "Gornals", "Grabulosa", "Granell", "Grau", "Graupera", "Griera", "Griful", "Grinyó", "Gual", "Guanyavents", "Guardans", "Guardiola", "Guarner", "Guau", "Gubern", "Güell", "Guerola", "Guia", "Guillaumet", "Guillemon", "Guim", "Guimerà", "Guinjoan", "Guinot", "Guiu", "Guix", "Guixer", "Hill", "Hortalà", "Hortolà", "Huguet", "Húnter", "Ibars", "Illa", "Inglada", "Irla", "Isern", "Isús", "Jardí", "Jaumà", "Jo", "Joandó", "Joaniquet", "Joncar", "Jordà", "Jordana", "Jounou", "Jover", "Juncadella", "Just", "Lairet", "Laporta", "Lastortras", "Letxa", "Llach", "Lladre", "Llambí", "Llambrich", "Llates", "Llauneta", "Lleget", "Lleonart", "Lletí", "Llevat", "Llidó", "Lligona", "Llobatera", "Llobell", "Llobera", "Llobet", "Llombart", "Llompart", "Llonch", "Llongueres", "Llop", "Llopis", "Llorach", "Llord", "Lloret", "Lluhí", "Llúria", "Llussà", "Luguel", "Macabies", "Macià", "Magem", "Magrinyà", "Maimó", "Mainar", "Majoral", "Malagarriga", "Mallafré", "Mallench", "Mallol", "Malonda", "Managuerra", "Manau", "Manent", "Manclús", "Marca", "Marçal", "Margarit", "Margenat", "Marginedes", "Maristany", "Marquès", "Marroig", "Mas", "Masdalmau", "Masdexeixars", "Masfort", "Masguillem", "Masoliver", "Maspons", "Masramon", "Massanet", "Massip", "Massó", "Masvidal", "Matabosc", "Mates", "Mató", "Mengual", "Mestre", "Mesull", "Micó", "Milà", "Millet", "Minguell", "Minguella", "Mir", "Mira", "Miracle", "Miralbell", "Miralles", "Miralpeix", "Mirats", "Miravitlles", "Miret", "Miró", "Miserachs", "Mitjana", "Mitjans", "Modolell", "Moles", "Moll", "Monells", "Monner", "Montanyà", "Montau", "Montellà", "Montells", "Montfulleda", "Montgai", "Montllor", "Montoliu", "Montpalau", "Montsalvatge", "Montserrat", "Moragues", "Moreu", "Morgades", "Morral", "Mosella", "Mota", "Mundó", "Muntaner", "Muntanya", "Muntanyola", "Murià", "Mut", "Nadal", "Nicou", "Nin", "Niubò", "Nomdedéu", "Noms", "Novell", "Nubiola", "Och", "Ochs", "Obiols", "Oliu", "Olivella", "Oliver", "Oller", "Om", "Oms", "Oranich", "Ordeig", "Ordeix", "Oristrell", "Oró", "Orriols", "Ors", "Ortells", "Ortiga", "Orts", "Pach", "Pagès", "Paimada", "Palau", "Palet", "Pallach", "Pallerola", "Panyella", "Papasseit", "Parera", "Paretes", "Parra", "Parramon", "Parramona", "Paulí", "Paüls", "Pausà", "Pedra", "Pedrol", "Pedrola", "Pedrolo", "Peguera", "Pei", "Peig", "Peix", "Pelegero", "Pella", "Pellicena", "Pellicer", "Peralta", "Peramartí", "Perarnau", "Perdigó", "Perdrix", "Perejoan", "Perera", "Peris", "Permanyer", "Petit", "Petitbo", "Petràs", "Pi", "Pibernat", "Picanyol", "Picó", "Picornell", "Pidecabanyes", "Pidelaserra", "Piferrer", "Pigem", "Pigrau", "Pijoan", "Pina", "Pineda", "Pintat", "Pinya", "Pinyol", "Piques", "Pla", "Plandolit", "Planelles", "Planxart", "Poal", "Poch", "Pomar", "Pomers", "Pontjoan", "Porcel", "Porta", "Pou", "Pous", "Prat", "Pratdesaba", "Pratginestós", "Prats", "Prenafeta", "Prim", "Pruna", "Pubill", "Pucurella", "Pucurull", "Puig", "Puigbò", "Puigcercós", "Puigcerdà", "Puigcorber", "Puigdecabanes", "Puigdefàbregues", "Puigdelabellacasa", "Puigdellívol", "Puigdemassa", "Puigdemont", "Puigdengoles", "Puigdevall", "Puigdollers", "Puigdomènech", "Puigferrer", "Puiggarí", "Puigivila", "Puigpelat", "Puigserver", "Puigsesllosses", "Puigtobella", "Puigverd", "Puigxoriguer", "Pujades", "Pujals", "Pujol", "Pujols", "Puxeu", "Quadreny", "Queixal", "Quera", "Qui", "Quixal", "Rabell", "Rabella", "Rabionet", "Rafanell", "Ràfols", "Rahola", "Ramis", "Ras", "Raspall", "Rata", "Rebull", "Recasens", "Recatalà", "Recoder", "Rectoret", "Remolar", "Renom", "Renyer", "Reig", "Reiners", "Reixach", "Reixachdamunt", "Reixachdavall", "Revelles", "Reventós", "Reverter", "Revés", "Riba", "Ribalta", "Ribelles", "Ribot", "Ricou", "Ridao", "Riembau", "Riera", "Rieradevall", "Rifà", "Rigau", "Rimbau", "Rissech", "Riudor", "Riutort", "Rocabert", "Rocabertí", "Rocafort", "Rocasalva", "Rodelles", "Rodorera", "Roglà", "Roig", "Roïra", "Roís", "Rom", "Romaní", "Romeva", "Rosdevall", "Rossell", "Rossinyol", "Rota", "Roure", "Rovira", "Roviralta", "Rovirosa", "Rubau", "Rubinat", "Rubió", "Ruïch", "Rutllant", "Sabarís", "Saber", "Saborit", "Sablich", "Sacirera", "Sala", "Saladrigues", "Salom", "Salort", "Salrach", "Saltor", "Salvà", "Salvany", "Salvat", "Salvatella", "Samaranch", "Samper", "Samsó", "Sanabre", "Santaeulàlia", "Santceloni", "Santllehí", "Santpere", "Santromà", "Sanxis", "Sardiner", "Sarrà", "Sarsanedes", "Saura", "Sauret", "Secanella", "Segimon", "Seguí", "Segura", "Seix", "Sellarès", "Selva", "Senespleda", "Senserrich", "Senties", "Sentís", "Serarols", "Serentill", "Serracant", "Serradelarca", "Serradesanferm", "Serrahima", "Serrallach", "Serrarols", "Serrat", "Serrats", "Seuba", "Siberta", "Sicart", "Sindreu", "Singla", "Sinyol", "Siscar", "Sistach", "Sobirana", "Sobirats", "Sobiratsdamunt", "Sobiratsdavall", "Sobregrau", "Sobrequés", "Soldevila", "Solei", "Soler", "Solivelles", "Soquer", "Sorribes", "Sospedra", "Suai", "Suau", "Sudrià", "Sugranyes", "Sunyer", "Sunyol", "Surinyach", "Suriol", "Surrallès", "Surroca", "Taix", "Tallada", "Tallaferro", "Tamarit", "Tàpies", "Tarongí", "Tarradelles", "Tarroja", "Tasis", "Tauler", "Taurinyà", "Tei", "Tell", "Terrafeta", "Ticó", "Timoneda", "Togores", "Toldrà", "Tolrà", "Torra", "Tornafoch", "Torregrossa", "Torrendell", "Torroglosa", "Tort", "Traguany", "Trèmols", "Tremosa", "Trenchs", "Triadú", "Tries", "Trinxet", "Trueta", "Trullols", "Turell", "Turró", "Turull", "Tutusaus", "Urpià", "Ullastre", "Usac", "Vallcorba", "Valldaura", "Valleriola", "Vallescà", "Vallplana", "Vallribera", "Vallverdú", "Valor", "Veguer", "Veiret", "Ventalló", "Ventosa", "Ventura", "Verdaguer", "Verdeny", "Vergós", "Vericat", "Viciana", "Vidagany", "Vidal ", "Vila", "Viladelprat", "Viladevall", "Viladoms", "Viladot", "Vilajosana", "Vilalba", "Vilalta", "Vilaplana", "Vilar", "Vilarasau", "Vilardaga", "Vilardebò", "Vilardell", "Vilarrasa", "Vinagre", "Vinyals", "Vinyeta", "Vinyoles", "Virgili", "Viu", "Viusà", "Vivet", "Vives", "Xammar", "Xampeny", "Xandri", "Xatard", "Xaus", "Xauvell", "Xercavins", "Xicoi", "Xicola", "Xinxilla", "Xinxò", "Xipell", "Xirau", "Xirgu", "Xirinachs", "Xoriguera", "Xuclà", "Xufré" };

            string commonPassword = "holahola", commonPasswordQuestion = "Salutació", commonPasswordAnswer = "holahola";

            Random rnd = new Random();

            // Elimina totes les files de les taules
            foreach (string tbl in tableNames)
                this.ObjectContext.ExecuteStoreCommand("delete " + tbl);

            // Crea els rols
            foreach (string name in roleNames)
                this.ObjectContext.Roles.AddObject(new Role() { Name = name });

            // Crea les direccions generals
            foreach (string name in directorateNames)
                this.ObjectContext.Directorates.AddObject(new Directorate() { Name = name });

            // Es graba per disposar dels canvis als entities
            this.ObjectContext.SaveChanges();

            // Crea els tipus d'òrgan de cada direcció general
            foreach (Directorate directorate in this.ObjectContext.Directorates)
                foreach (string name in organTypeNames)
                    this.ObjectContext.OrganTypes.AddObject(
                        new OrganType()
                        {
                            Name = name,
                            Directorate = directorate
                        }
                    );

            // Es graba per disposar dels canvis als entities
            this.ObjectContext.SaveChanges();

            // Crea els òrgans principals
            foreach (Directorate directorate in this.ObjectContext.Directorates)
                this.ObjectContext.Organs.AddObject(
                    new Organ()
                    {
                        Name = directorate.Name,
                        Role = this.ObjectContext.Roles.FirstOrDefault(r => r.Name == roleAdministrator),
                        OrganType = this.ObjectContext.OrganTypes
                            .FirstOrDefault(o => o.Name == organTypeDG && o.DirectorateId == directorate.DirectorateId)
                    }
                );

            // Crea els òrgans de les direccions generals
            foreach (Directorate directorate in this.ObjectContext.Directorates)
            {
                for (int i = 1; i < organs; i++)
                {
                    this.ObjectContext.Organs.AddObject(
                        new Organ()
                        {
                            Name = "Organ " + i,
                            Parent = this.ObjectContext.Organs
                                .Where(o => o.OrganType.DirectorateId == directorate.DirectorateId)
                                .OrderBy(x => Guid.NewGuid()).FirstOrDefault(),
                            Role = this.ObjectContext.Roles.FirstOrDefault(r => r.Name == roleMapMaker),
                            OrganType = this.ObjectContext.OrganTypes
                                .FirstOrDefault(o => o.Name == organTypeGeneric && o.DirectorateId == directorate.DirectorateId)
                        }
                    );
                }
                this.ObjectContext.Organs.AddObject(
                    new Organ()
                    {
                        Name = "Gestors",
                        Parent = this.ObjectContext.Organs
                            .Where(o => o.OrganType.DirectorateId == directorate.DirectorateId)
                            .OrderBy(x => Guid.NewGuid()).FirstOrDefault(),
                        Role = this.ObjectContext.Roles.FirstOrDefault(r => r.Name == roleManager),
                        OrganType = this.ObjectContext.OrganTypes
                            .FirstOrDefault(o => o.Name == organTypeManagers && o.DirectorateId == directorate.DirectorateId)
                    }
                );
            }

            // Es graba per disposar dels canvis als entities
            this.ObjectContext.SaveChanges();

            for (int i = 1; i < usuaris; i++)
            {
                // Crea les identitats dels usuaris
                Person person = new Person()
                {
                    FirstName = firstNames[rnd.Next(firstNames.Length)],
                    FirstLastName = lastNames[rnd.Next(lastNames.Length)],
                    SecondLastName = lastNames[rnd.Next(lastNames.Length)],
                };
                this.ObjectContext.Identities.AddObject(person);
                // Crea una targeta d'identitat per cada persona
                IdentityCard identityCard = new IdentityCard()
                {
                    Number = new NIF().Random,
                    Type = IdentityCardType.NIF,
                    Person = person
                };
                this.ObjectContext.IdentityCards.AddObject(identityCard);
                // Crea un usuari per a cada identitat
                Directorate directorate = this.ObjectContext.Directorates
                            .OrderBy(x => Guid.NewGuid()).FirstOrDefault();
                User user = new User()
                {
                    Identity = person,
                    Directorate = directorate,
                    Organ = this.ObjectContext.Organs
                        .Where(o => o.OrganType.DirectorateId == directorate.DirectorateId)
                        .OrderBy(x => Guid.NewGuid()).FirstOrDefault(),
                    UserName = string.Format("{0}.{1}.{2}", person.FirstName, person.FirstLastName, person.SecondLastName)
                };
                this.ObjectContext.Users.AddObject(user);
                // Crea una subscripció per a cada usuari
                string passwordSalt = HashHelper.CreateRandomSalt();
                string passwordAnswerSalt = HashHelper.CreateRandomSalt();
                Membership member = new Membership()
                {
                    User = user,
                    Email = string.Format("{0}@gencat.cat", user.UserName),
                    PasswordHash = HashHelper.ComputeSaltedHash(() => commonPassword, passwordSalt),
                    PasswordSalt = passwordSalt,
                    PasswordQuestion = commonPasswordQuestion,
                    PasswordAnswerHash = HashHelper.ComputeSaltedHash(() => commonPasswordAnswer, passwordAnswerSalt),
                    PasswordAnswerSalt = passwordAnswerSalt
                };
                this.ObjectContext.Memberships.AddObject(member);
            }

            // Es graba per disposar dels canvis als entities
            this.ObjectContext.SaveChanges();

            // Es retornen els usuaris
            return this.ObjectContext.Users;
            //return string.Format("Base de dades generada amb {0} usuaris.", this.ObjectContext.Users.Count());
        }

        #region Directorate services

        #region Directorates

        [Query(IsDefault = true)]
        public IQueryable<Directorate> GetDirectorates()
        {
            return this.ObjectContext.Directorates;
        }

        public Directorate GetDirectorate(int directorateId)
        {
            return this.ObjectContext.Directorates.FirstOrDefault(d => d.DirectorateId == directorateId);
        }

        public void InsertDirectorate(Directorate directorate)
        {
            if ((directorate.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(directorate, EntityState.Added);
            }
            else
            {
                this.ObjectContext.Directorates.AddObject(directorate);
            }
        }

        public void UpdateDirectorate(Directorate currentDirectorate)
        {
            this.ObjectContext.Directorates.AttachAsModified(currentDirectorate, this.ChangeSet.GetOriginal(currentDirectorate));
        }

        public void DeleteDirectorate(Directorate directorate)
        {
            if ((directorate.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(directorate, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.Directorates.Attach(directorate);
                this.ObjectContext.Directorates.DeleteObject(directorate);
            }
        }

        #endregion

        #region Buildings

        [Query(IsDefault = true)]
        public IQueryable<Building> GetBuildings()
        {
            return this.ObjectContext.Buildings;
        }

        public void InsertBuilding(Building building)
        {
            if ((building.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(building, EntityState.Added);
            }
            else
            {
                this.ObjectContext.Buildings.AddObject(building);
            }
        }

        public void UpdateBuilding(Building currentBuilding)
        {
            this.ObjectContext.Buildings.AttachAsModified(currentBuilding, this.ChangeSet.GetOriginal(currentBuilding));
        }

        public void DeleteBuilding(Building building)
        {
            if ((building.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(building, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.Buildings.Attach(building);
                this.ObjectContext.Buildings.DeleteObject(building);
            }
        }

        #endregion

        #region BuildingTypes

        [Query(IsDefault = true)]
        public IQueryable<BuildingType> GetBuildingTypes()
        {
            return this.ObjectContext.BuildingTypes;
        }

        public void InsertBuildingType(BuildingType buildingType)
        {
            if ((buildingType.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(buildingType, EntityState.Added);
            }
            else
            {
                this.ObjectContext.BuildingTypes.AddObject(buildingType);
            }
        }

        public void UpdateBuildingType(BuildingType currentBuildingType)
        {
            this.ObjectContext.BuildingTypes.AttachAsModified(currentBuildingType, this.ChangeSet.GetOriginal(currentBuildingType));
        }

        public void DeleteBuildingType(BuildingType buildingType)
        {
            if ((buildingType.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(buildingType, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.BuildingTypes.Attach(buildingType);
                this.ObjectContext.BuildingTypes.DeleteObject(buildingType);
            }
        }

        #endregion

        #region Organs

        [Query(IsDefault = true)]
        public IQueryable<Organ> GetOrgans()
        {
            return this.ObjectContext.Organs;
        }

        public void InsertOrgan(Organ organ)
        {
            if ((organ.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(organ, EntityState.Added);
            }
            else
            {
                this.ObjectContext.Organs.AddObject(organ);
            }
        }

        public void UpdateOrgan(Organ currentOrgan)
        {
            this.ObjectContext.Organs.AttachAsModified(currentOrgan, this.ChangeSet.GetOriginal(currentOrgan));
        }

        public void DeleteOrgan(Organ organ)
        {
            if ((organ.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(organ, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.Organs.Attach(organ);
                this.ObjectContext.Organs.DeleteObject(organ);
            }
        }

        #endregion

        #region OrganTypes

        [Query(IsDefault = true)]
        public IQueryable<OrganType> GetOrganTypes()
        {
            return this.ObjectContext.OrganTypes;
        }

        public void InsertOrganType(OrganType organType)
        {
            if ((organType.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(organType, EntityState.Added);
            }
            else
            {
                this.ObjectContext.OrganTypes.AddObject(organType);
            }
        }

        public void UpdateOrganType(OrganType currentOrganType)
        {
            this.ObjectContext.OrganTypes.AttachAsModified(currentOrganType, this.ChangeSet.GetOriginal(currentOrganType));
        }

        public void DeleteOrganType(OrganType organType)
        {
            if ((organType.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(organType, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.OrganTypes.Attach(organType);
                this.ObjectContext.OrganTypes.DeleteObject(organType);
            }
        }

        #endregion

        #endregion

        #region User services

        #region Identities

        [Query(IsDefault = true)]
        public IQueryable<Identity> GetIdentities()
        {
            return this.ObjectContext.Identities;
        }

        public void InsertIdentity(Identity identity)
        {
            if ((identity.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(identity, EntityState.Added);
            }
            else
            {
                this.ObjectContext.Identities.AddObject(identity);
            }
        }

        public void UpdateIdentity(Identity currentIdentity)
        {
            this.ObjectContext.Identities.AttachAsModified(currentIdentity, this.ChangeSet.GetOriginal(currentIdentity));
        }

        public void DeleteIdentity(Identity identity)
        {
            if ((identity.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(identity, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.Identities.Attach(identity);
                this.ObjectContext.Identities.DeleteObject(identity);
            }
        }

        #endregion

        #region IdentityCards

        [Query(IsDefault = true)]
        public IQueryable<IdentityCard> GetIdentityCards()
        {
            return this.ObjectContext.IdentityCards;
        }

        public void InsertIdentityCard(IdentityCard identityCard)
        {
            if ((identityCard.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(identityCard, EntityState.Added);
            }
            else
            {
                this.ObjectContext.IdentityCards.AddObject(identityCard);
            }
        }

        public void UpdateIdentityCard(IdentityCard currentIdentityCard)
        {
            this.ObjectContext.IdentityCards.AttachAsModified(currentIdentityCard, this.ChangeSet.GetOriginal(currentIdentityCard));
        }

        public void DeleteIdentityCard(IdentityCard identityCard)
        {
            if ((identityCard.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(identityCard, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.IdentityCards.Attach(identityCard);
                this.ObjectContext.IdentityCards.DeleteObject(identityCard);
            }
        }

        #endregion

        #region Memberships

        [Query(IsDefault = true)]
        public IQueryable<Membership> GetMemberships()
        {
            return this.ObjectContext.Memberships;
        }

        public void InsertMembership(Membership membership)
        {
            if ((membership.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(membership, EntityState.Added);
            }
            else
            {
                this.ObjectContext.Memberships.AddObject(membership);
            }
        }

        public void UpdateMembership(Membership currentMembership)
        {
            this.ObjectContext.Memberships.AttachAsModified(currentMembership, this.ChangeSet.GetOriginal(currentMembership));
        }

        public void DeleteMembership(Membership membership)
        {
            if ((membership.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(membership, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.Memberships.Attach(membership);
                this.ObjectContext.Memberships.DeleteObject(membership);
            }
        }

        #endregion

        #region Roles

        [Query(IsDefault = true)]
        public IQueryable<Role> GetRoles()
        {
            return this.ObjectContext.Roles;
        }

        public void InsertRole(Role role)
        {
            if ((role.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(role, EntityState.Added);
            }
            else
            {
                this.ObjectContext.Roles.AddObject(role);
            }
        }

        public void UpdateRole(Role currentRole)
        {
            this.ObjectContext.Roles.AttachAsModified(currentRole, this.ChangeSet.GetOriginal(currentRole));
        }

        public void DeleteRole(Role role)
        {
            if ((role.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(role, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.Roles.Attach(role);
                this.ObjectContext.Roles.DeleteObject(role);
            }
        }

        #endregion

        #region Users

        // TODO:
        // Considere la posibilidad de restringir los resultados de su método de consulta. Si necesita entradas adicionales, puede
        // agregar parámetros a este método o crear métodos de consulta adicionales con distintos nombres.
        // Para admitir la paginación tendrá que agregar ordenación a la consulta 'Users'.
        [Query(IsDefault = true)]
        public IQueryable<User> GetUsers()
        {
            return this.ObjectContext.Users;
        }

        public void InsertUser(User user)
        {
            if ((user.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(user, EntityState.Added);
            }
            else
            {
                this.ObjectContext.Users.AddObject(user);
            }
        }

        public void UpdateUser(User currentUser)
        {
            this.ObjectContext.Users.AttachAsModified(currentUser, this.ChangeSet.GetOriginal(currentUser));
        }

        public void DeleteUser(User user)
        {
            if ((user.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(user, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.Users.Attach(user);
                this.ObjectContext.Users.DeleteObject(user);
            }
        }

        #endregion

        #endregion

        #region Spatial services

        #region MapLayers

        [Query(IsDefault = true)]
        public IQueryable<MapLayer> GetMapLayers()
        {
            return this.ObjectContext.MapLayers;
        }

        public void InsertMapLayer(MapLayer mapLayer)
        {
            if ((mapLayer.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mapLayer, EntityState.Added);
            }
            else
            {
                this.ObjectContext.MapLayers.AddObject(mapLayer);
            }
        }

        public void UpdateMapLayer(MapLayer currentMapLayer)
        {
            this.ObjectContext.MapLayers.AttachAsModified(currentMapLayer, this.ChangeSet.GetOriginal(currentMapLayer));
        }

        public void DeleteMapLayer(MapLayer mapLayer)
        {
            if ((mapLayer.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mapLayer, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.MapLayers.Attach(mapLayer);
                this.ObjectContext.MapLayers.DeleteObject(mapLayer);
            }
        }

        #endregion

        #region MapShapes

        [Query(IsDefault = true)]
        public IQueryable<MapShape> GetMapShapes()
        {
            return this.ObjectContext.MapShapes;
        }

        public void InsertMapShape(MapShape mapShape)
        {
            if ((mapShape.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mapShape, EntityState.Added);
            }
            else
            {
                this.ObjectContext.MapShapes.AddObject(mapShape);
            }
        }

        public void UpdateMapShape(MapShape currentMapShape)
        {
            this.ObjectContext.MapShapes.AttachAsModified(currentMapShape, this.ChangeSet.GetOriginal(currentMapShape));
        }

        public void DeleteMapShape(MapShape mapShape)
        {
            if ((mapShape.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(mapShape, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.MapShapes.Attach(mapShape);
                this.ObjectContext.MapShapes.DeleteObject(mapShape);
            }
        }

        #endregion

        #region OgcGroups

        [Query(IsDefault = true)]
        public IQueryable<OgcGroup> GetOgcGroups()
        {
            return this.ObjectContext.OgcGroups;
        }

        public void InsertOgcGroup(OgcGroup ogcGroup)
        {
            if ((ogcGroup.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(ogcGroup, EntityState.Added);
            }
            else
            {
                this.ObjectContext.OgcGroups.AddObject(ogcGroup);
            }
        }

        public void UpdateOgcGroup(OgcGroup currentOgcGroup)
        {
            this.ObjectContext.OgcGroups.AttachAsModified(currentOgcGroup, this.ChangeSet.GetOriginal(currentOgcGroup));
        }

        public void DeleteOgcGroup(OgcGroup ogcGroup)
        {
            if ((ogcGroup.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(ogcGroup, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.OgcGroups.Attach(ogcGroup);
                this.ObjectContext.OgcGroups.DeleteObject(ogcGroup);
            }
        }

        #endregion

        #region OgcLayers

        [Query(IsDefault = true)]
        public IQueryable<OgcLayer> GetOgcLayers()
        {
            return this.ObjectContext.OgcLayers;
        }

        public void InsertOgcLayer(OgcLayer ogcLayer)
        {
            if ((ogcLayer.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(ogcLayer, EntityState.Added);
            }
            else
            {
                this.ObjectContext.OgcLayers.AddObject(ogcLayer);
            }
        }

        public void UpdateOgcLayer(OgcLayer currentOgcLayer)
        {
            this.ObjectContext.OgcLayers.AttachAsModified(currentOgcLayer, this.ChangeSet.GetOriginal(currentOgcLayer));
        }

        public void DeleteOgcLayer(OgcLayer ogcLayer)
        {
            if ((ogcLayer.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(ogcLayer, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.OgcLayers.Attach(ogcLayer);
                this.ObjectContext.OgcLayers.DeleteObject(ogcLayer);
            }
        }

        #endregion

        #region PoiLayers

        [Query(IsDefault = true)]
        public IQueryable<PoiLayer> GetPoiLayers()
        {
            return this.ObjectContext.PoiLayers;
        }

        public void InsertPoiLayer(PoiLayer poiLayer)
        {
            if ((poiLayer.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(poiLayer, EntityState.Added);
            }
            else
            {
                this.ObjectContext.PoiLayers.AddObject(poiLayer);
            }
        }

        public void UpdatePoiLayer(PoiLayer currentPoiLayer)
        {
            this.ObjectContext.PoiLayers.AttachAsModified(currentPoiLayer, this.ChangeSet.GetOriginal(currentPoiLayer));
        }

        public void DeletePoiLayer(PoiLayer poiLayer)
        {
            if ((poiLayer.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(poiLayer, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.PoiLayers.Attach(poiLayer);
                this.ObjectContext.PoiLayers.DeleteObject(poiLayer);
            }
        }

        #endregion

        #region PoiShapes

        [Query(IsDefault = true)]
        public IQueryable<PoiShape> GetPoiShapes()
        {
            return this.ObjectContext.PoiShapes;
        }

        public void InsertPoiShape(PoiShape poiShape)
        {
            if ((poiShape.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(poiShape, EntityState.Added);
            }
            else
            {
                this.ObjectContext.PoiShapes.AddObject(poiShape);
            }
        }

        public void UpdatePoiShape(PoiShape currentPoiShape)
        {
            this.ObjectContext.PoiShapes.AttachAsModified(currentPoiShape, this.ChangeSet.GetOriginal(currentPoiShape));
        }

        public void DeletePoiShape(PoiShape poiShape)
        {
            if ((poiShape.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(poiShape, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.PoiShapes.Attach(poiShape);
                this.ObjectContext.PoiShapes.DeleteObject(poiShape);
            }
        }

        #endregion

        #region Symbols

        [Query(IsDefault = true)]
        public IQueryable<Symbol> GetSymbols()
        {
            return this.ObjectContext.Symbols;
        }

        public void InsertSymbol(Symbol symbol)
        {
            if ((symbol.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(symbol, EntityState.Added);
            }
            else
            {
                this.ObjectContext.Symbols.AddObject(symbol);
            }
        }

        public void UpdateSymbol(Symbol currentSymbol)
        {
            this.ObjectContext.Symbols.AttachAsModified(currentSymbol, this.ChangeSet.GetOriginal(currentSymbol));
        }

        public void DeleteSymbol(Symbol symbol)
        {
            if ((symbol.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(symbol, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.Symbols.Attach(symbol);
                this.ObjectContext.Symbols.DeleteObject(symbol);
            }
        }

        #endregion

        #endregion

        #region Audit services

        #region Audits

        [Query(IsDefault = true)]
        public IQueryable<Audit> GetAudits()
        {
            return this.ObjectContext.Audits;
        }

        public void InsertAudit(Audit audit)
        {
            if ((audit.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(audit, EntityState.Added);
            }
            else
            {
                this.ObjectContext.Audits.AddObject(audit);
            }
        }

        public void UpdateAudit(Audit currentAudit)
        {
            this.ObjectContext.Audits.AttachAsModified(currentAudit, this.ChangeSet.GetOriginal(currentAudit));
        }

        public void DeleteAudit(Audit audit)
        {
            if ((audit.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(audit, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.Audits.Attach(audit);
                this.ObjectContext.Audits.DeleteObject(audit);
            }
        }

        #endregion

        #region AuditFields

        [Query(IsDefault = true)]
        public IQueryable<AuditField> GetAuditFields()
        {
            return this.ObjectContext.AuditFields;
        }

        public void InsertAuditField(AuditField auditField)
        {
            if ((auditField.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(auditField, EntityState.Added);
            }
            else
            {
                this.ObjectContext.AuditFields.AddObject(auditField);
            }
        }

        public void UpdateAuditField(AuditField currentAuditField)
        {
            this.ObjectContext.AuditFields.AttachAsModified(currentAuditField, this.ChangeSet.GetOriginal(currentAuditField));
        }

        public void DeleteAuditField(AuditField auditField)
        {
            if ((auditField.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(auditField, EntityState.Deleted);
            }
            else
            {
                this.ObjectContext.AuditFields.Attach(auditField);
                this.ObjectContext.AuditFields.DeleteObject(auditField);
            }
        }

        #endregion

        #endregion

    }
}
