﻿
namespace Sigcat.Server.WcfSvcLib
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.ComponentModel.DataAnnotations;
    using System.Linq;
    using System.ServiceModel.DomainServices.Hosting;
    using System.ServiceModel.DomainServices.Server;

    [EnableClientAccess()]
    public class TestSvc : DomainService, ITestService
    {

        #region ITestService implementation

        /// <summary>
        /// Verifica que el servei web és correcte.
        /// Serveix per realitzar proves de connexió.
        /// </summary>
        /// <returns>
        /// Un objecte <see cref="TestServiceResult"/>
        /// que confirma que s'ha realitzat la connexió.
        /// </returns>
        public TestServiceResult Test()
        {
            var result = new TestServiceResult()
            {
                ServiceName = this.GetType().Name,
                Tested = true
            };
            return result;
        }

        #endregion
    }

    public interface ITestService
    {
        /// <summary>
        /// Verifica que el servei web és correcte.
        /// Serveix per realitzar proves de connexió.
        /// </summary>
        /// <returns>
        /// Un objecte <see cref="TestServiceResult"/>
        /// que confirma que s'ha realitzat la connexió.
        /// </returns>
        TestServiceResult Test();
    }

    public class TestServiceResult
    {
        [Key]
        public Guid Id { get; set; }
        public string ServiceName { get; set; }
        public bool Tested { get; set; }
        public TestServiceResult()
        {
            Id = Guid.NewGuid();
            ServiceName = null;
            Tested = false;
        }
    }

}
